<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
//////■ 以下スクリプト ■////
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// 外部ファイル読み込み
require_once('common.php');

// セッション設定
ini_set('session.gc_maxlifetime', 1800);
ini_set('session.gc_probability', 1);
ini_set('session.gc_divisor', 100);
ini_set('session.hash_function', 1);
ini_set('session.hash_bits_per_character', 5);
ini_set('session.cookie_path', '/');
ini_set('session.cookie_domain', '');
session_name('mwhgsess');
session_save_path(SESSIONDIR. '/');
session_start();

// 処理分岐
if (get_query('mode') === 'logout') {
	// ▼ログアウト
	logout();
} else if (get_post('mode') === 'login') {
	// ▼ログイン
	login();
} else {
	$sessname = get_cookie(session_name());
	if ( ! is_null($sessname) && file_exists(session_save_path(). 'sess_'. $sessname) && get_session('password') === MSKEY) {
		$act = get_post('act', get_query('act'));
		switch ($act) {
			case 'import':
				// ▼インポート
				import();
				break;
			case 'systemconfig':
				// ▼システム設定
				systemconfig();
				break;
			case 'clapconfig':
				// ▼基本拍手設定
				clapconfig();
				break;
			case 'chart':
				// ▼チャート
				chart();
				break;
			case 'clapid':
				// ▼ID一覧
				clapid();
				break;
			default:
				// ▼トップページ（日付別拍手一覧）
				top();
				break;
		}
	} else {
		// ▼ログインフォーム
		login_form();
	}
}
exit;
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ログイン
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function login() {
	$password = get_post('password');
	if ($password !== MSKEY) {
		$_SESSION['error'] = 'パスワードが間違っています';
	} else {
		session_regenerate();
		$_SESSION['password'] = $password;
	}
	location($GLOBALS['script']);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ログアウト
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function logout() {
	$sessname = get_cookie(session_name());
	$_SESSION = array();
	if ( ! empty($sessname)) setcookie(session_name(), '', time()-42000, '/');
	// if (get_cookie('alk') != null) setcookie('alk', '', time()-42000, '/');
	session_destroy();
	location($GLOBALS['script']);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ トップページ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function top() {
	$_SESSION['msgonly'] = get_query('msgonly', get_session('msgonly', 'off'));
	$_SESSION['viewtype'] = get_query('viewtype', get_session('viewtype', 'timeline'));
	$_SESSION['viewlabel'] = get_query('viewlabel', get_session('viewlabel', 'view'));
	$_SESSION['viewhost'] = get_query('viewhost', get_session('viewhost', 'view'));

	// $nowtime = time() + 9 * 60 * 60;
	$nowtime	= time();
	$stttime		= $nowtime;
	$endtime		= $nowtime;

	$datesel	= get_query('datesel');
	$specify	= get_query('specify');

	if ( ! is_null(get_query('year')) && ! is_null(get_query('month')) && ! is_null(get_query('day'))) {
		$stttime	= mktime(0, 0, 0, get_query('month'), get_query('day'), get_query('year'));
		$endtime	= $stttime;
	}

	$year			= date("Y", $stttime);
	$month	= date("n", $stttime);
	$day			= date("j", $stttime);

	html_header();
	content_header();

	// ▼カレンダー
	echo '
	<div class="row">
		<div class="col-md-9 col-md-push-3 col-lg-10 col-lg-push-2">
		';

		// ▼日付別拍手
		datetotal($stttime, $endtime);

		echo '
		</div>
		<div class="col-md-3 col-md-pull-9 col-lg-2 col-lg-pull-10">
			<div class="text-center">
				<div class="btn-group">
					<a href="'. $GLOBALS['script']. '?'. $_SERVER['QUERY_STRING']. '&viewtype=timeline" class="btn btn-default btn-sm'. (($_SESSION['viewtype'] === 'timeline') ? ' active' : ''). '">タイムライン</a>
					<a href="'. $GLOBALS['script']. '?'. $_SERVER['QUERY_STRING']. '&viewtype=list" class="btn btn-default btn-sm'. (($_SESSION['viewtype'] === 'list') ? ' active' : ''). '">リスト</a>
				</div>
			</div>
			<hr />
			<div class="panel panel-default">
				<div class="panel-heading text-center">
					<span class="btn-group">
						<a href="'. $GLOBALS['script']. '?'. date('&\y\e\a\r=Y&\m\o\n\t\h=n&\d\a\y=d', strtotime(date('Y-m-d', $stttime).' -1 month')).'" title="back month" class="btn btn-default btn-xs"><i class="glyphicon glyphicon-chevron-left"></i></a>
						<a class="btn btn-default btn-xs disabled">'. date('Y年n月', $stttime). '</a>
						<a href="'. $GLOBALS['script']. '?'. date('&\y\e\a\r=Y&\m\o\n\t\h=n&\d\a\y=d', strtotime(date('Y-m-d', $stttime). ' +1 month')).'" title="next month" class="btn btn-default btn-xs"><i class="glyphicon glyphicon-chevron-right"></i></a>
					</span>
				</div>
				<table class="table table-striped table-bordered table-condensed" id="calendar">
					<thead>
						<tr>
							<th class="text-danger">日</th>
							<th>月</th>
							<th>火</th>
							<th>水</th>
							<th>木</th>
							<th>金</th>
							<th class="text-primary">土</th>
						</tr>
					</thead>
					<tbody>
					';

					//月末の取得
					$l_day = date("j", mktime(0, 0, 0, $month + 1, 0, $year));

					$lc = 0;
					//月末分繰り返す
					for ($i = 1; $i < $l_day + 1;$i++) {
						$mktime = mktime(0, 0, 0, $month, $i, $year);
						//曜日の取得
						$week = date("w", $mktime);
						//曜日が日曜日の場合
						if ($week == 0) {
							echo '<tr>';
							$lc++;
						}
						//1日の場合
						if ($i == 1) {
							if($week != 0) {
								echo '<tr>';
								$lc++;
							}
							echo repeat($week);
						}
						echo '<td class="';
						if ((( ! is_null($datesel) || ! is_null($specify)) && $mktime <= $endtime && $mktime >= $stttime) or $i == $day) {
							// 選択中の日
							echo ' danger';
						}
						if (date('Y-n-j', $mktime) === date('Y-n-j')) {
							//現在の日付の場合
							echo ' active';
						}
						echo '">';
						$dfile = DATADIR.DATEDIR.sprintf("%04d/%02d-%02d", $year, $month, $i).'.dat';
						if (file_exists($dfile)) {
							// 拍手があった日
							echo '<a href="'.$GLOBALS['script']. '?year='.$year.'&month='.$month.'&day='.$i.'" class="wrap">'.$i.'</a></td>';
						} else {
							echo '<span class="wrap">'.$i.'</span></td>';
						}
						//月末の場合
						if ($i == $l_day) {
							echo repeat(6 - $week);
						}
						//土曜日の場合
						if($week == 6) {
							echo '</tr>';
						}
					}
					if($lc < 6) {
						echo '<tr>';
						echo repeat(7);
						echo '</tr>';
					}
					if($lc == 4) {
						echo '<tr>';
						echo repeat(7);
						echo '</tr>';
					}

					echo '
					</tbody>
				</table>
			</div>
		</div>
	</div>
	';

	content_footer();
	html_footer();
}
function repeat($n) {
	return str_repeat("<td></td>\n", $n);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 日付別拍手
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function datetotal($stttime, $endtime) {
	$url = $GLOBALS['script']. '?'. $_SERVER['QUERY_STRING'];

	$qid				= get_query('id');
	$qhost			= get_query('host');
	$msgonly		= get_session('msgonly');
	$viewhost	= get_session('viewhost');
	$viewlabel	= get_session('viewlabel');
	$viewtype	= get_session('viewtype');

	$allclap			= 0;
	$ttlclap				= 0;
	$CLAPLABEL	= array();
	$CLAPUSER	= array();

	$clappagemaxs							= array(10, 20, 30, 40, 50);
	$_SESSION['clapviewmax']	= get_query('clapviewmax', get_session('clapviewmax', $clappagemaxs[0]));
	$page												= get_query('page', 1);

	$ctmp = '';
	for ($t = $endtime; $t >= $stttime; $t -= 60 * 60 * 24) {
		$daydata = file_read(DATADIR. DATEDIR. date("Y/m-d", $t). '.dat', true);
		$DFILE = array_reverse($daydata);
		$dcount = count($DFILE);
		for ($i = 0; $i < $dcount; $i++) {
			list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", rtrim($DFILE[$i], "\n"));

			if (
				( ! empty($qid) && $qid !== $id)
			or
				( ! empty($qhost) && $qhost !== $host)
			or
				($msgonly === 'on' && empty($message))
			) continue;

			$allclap++;
			$ttlclap += $chain;

			if ($host !== 'none' && $host !== '') $CLAPUSER[$host] = 1;

			if (($page > 1 && $allclap <= (($page-1) * $_SESSION['clapviewmax'])) or $allclap > ($page * $_SESSION['clapviewmax'])) continue;

			// IDラベル
			if ( ! isset($CLAPLABEL[$id])) {
				$cd = file_read(DATADIR. IDDIR. $id. '.json');
				$CD = json_decode((is_null($cd) ? '{"label : null"}' : $cd), true);
				$CLAPLABEL[$id] = $CD['label'];
			}
			$idlink = '<a href="'. $url. '&host='. $qhost. '&id='. $id. '">'. $id. '</a>';
			if ($viewlabel === 'view' && ! empty($CLAPLABEL[$id])) $idlink .= '<div class="text-muted">['.$CLAPLABEL[$id].']</div>';

			// 名前・評価
			$nametmp = ($name !== '') ? '<b class="text-muted">'. $name. '</b>' : '';
			$evaltmp = ($eval !== '') ? ' [評価: '. $eval. ']' : '';

			// ホスト
			// 	<td><input type="text" value="'.$host.'" size="20" /></td>
			$hosttmp = ($viewhost === 'view') ? ' <small class="text-muted">[<a href="'. $url. '&id='. $qid. '&host='. $host. '" class="text-muted">'. $host. '</a>]</small>' : '';

			if ($viewtype === 'timeline') {
				// タイムライン表示
				if ($ctmp == '' || $i == 0) {
					$ctmp .= '
					<li class="timescore">
						<div class=" label label-muted">'. date("Y年m月d日", $time). '('. week($time). ')'. '</div>
					</li>
					';
				}
				$ctmp .= '
				<li>
					<div class="timeline-point">
						<div class="time text-muted">'. date(" H:i", $time). '<br /></div>
						<div class="label label-danger">'. $chain. ' clap!</div>
						<div class="clapid">'. $idlink. '</div>
					</div>
					<div class="timeline-panel">
					';
						if ( ! empty($message) || ! empty($name)) {
							$ctmp .= '
							<div class="timeline-message">
								<div class="timeline-body">
									'. $message. '
								</div>
							</div>
							';
						}
						$ctmp .= '
						<div class="details text-muted">'. $nametmp. $hosttmp. '&nbsp;</div>
					</div>
				</li>
				';
			} else {
				// テーブル表示
				$ctmp .= '
				<tr>
					<td>'. date("Y/m/d", $time). '('. week($time). ')'. date(" H:i", $time). '</td>
					<td nowrap="nowrap">'. $idlink. '</td>
					<td><strong class="text-danger">'. $chain. '</strong></td>
					<td><div>'. $message. '</div>'. $nametmp. $evaltmp. $hosttmp. '</td>
				</tr>
				';
			}
		}
	}

	// 表示内容
	$listcont = '';
	if ( ! is_null(get_query('datesel')) ||  ! is_null(get_query('specify'))) {
		$listcont .= date("Y年n月j日", $endtime).' ～ '.date("Y年n月j日", $stttime);
	} else {
		$listcont .= date("Y年n月j日", $stttime);
	}

	if ( ! empty($qid)) $listcont .= ' ID:'. $qid;
	if ( ! empty($qhost)) $listcont .= ' ホスト/IP:'. $qhost;

	if ($viewtype === 'timeline') {
		echo '
		<h4>日付別拍手 <small>'. $listcont. '</small></h4>
		<small>
		拍手人数: <strong class="text-danger">'. count($CLAPUSER). '</strong>
		合計拍手: <strong class="text-danger">'. $ttlclap. '</strong>
		</small>
		<hr />
		<ul class="timeline">
			'. $ctmp. '
		</ul>
		';
	} else {
		echo '
		<div class="panel panel-default">
			<div class="panel-heading">
				日付別拍手 - '. $listcont. '
			</div>
			<div class="panel-body">
				<small>
				拍手人数: <strong class="text-danger">'. count($CLAPUSER). '</strong>
				合計拍手: <strong class="text-danger">'. $ttlclap. '</strong>
				</small>
			</div>
			<table class="table table-striped">
				<thead>
					<tr>
						<th width="15%">時刻</th>
						<th width="'. (($viewlabel === 'view') ? '20%">ID[ラベル]' : '25%">ID'). '</th>
						<th width="9%">拍手数</th>
						<th>メッセージ'. (($viewhost === 'view') ? '[ホスト/IP]' : ''). '</th>
					</tr>
				</thead>
				<tbody>
				'.$ctmp.'
				</tbody>
			</table>
		</div>
		';
	}

	echo '
	<div class="row">
		<div class="col-md-9">
		';

		if ($allclap > $_SESSION['clapviewmax']) {
			echo '<ul class="pagination">';
				// 前へ
				if ($page != 1) {
					$back = $page - 1;
					echo '<li><a href="'. $url. '&page='. $back. '">&laquo; 前へ</a></li>';
				}

				// ページ移動
				$x = (($allclap != 0) && ($_SESSION['clapviewmax'] != 0)) ? ceil($allclap / $_SESSION['clapviewmax']) : 0;
				for ($y = 1; $y <= $x; $y++) {
					if ($y == $page) {
						echo '<li class="active"><a href="#">'. $y. '</a></li>';
					} else {
						echo '<li><a href="'. $url. '&page='. $y. '">'. $y. '</a></li>';
					}
				}
				// 次へ
				if (($page * $_SESSION['clapviewmax']) < $allclap) {
					$next = $page + 1;
					echo '<li><a href="'. $url. '&page='. $next. '">次へ &raquo;</a></li>';
				}
			echo '</ul>';
		}

		echo '
		</div>
		<div class="col-md-3">
			';
			if ($allclap > $clappagemaxs[0]) {
				echo '
				<form class="form-inline" role="form" style="margin-top: 20px;">
					<div class="form-group">
						<label class="control-label" for="clappagemax">表示件数</label>
						<select class="form-control" name="clappagemax" id="clappagemax" onchange="location.href = \''. $url. '&clapviewmax=\' + this.options[this.selectedIndex].innerHTML;">
							'. select_option($clappagemaxs, array_search($_SESSION['clapviewmax'], $clappagemaxs)). '
						</select>
					</div>
				</form>
				';
			}
		echo '
		</div>
	</div>
	';
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ID一覧
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clapid() {
	$cachefile = DATADIR. 'all_id.json';
	$cmd = get_post('cmd', get_query('cmd'));
	switch ($cmd) {
		case 'add':
			// ▼追加
			if ($_SERVER['REQUEST_METHOD'] === 'POST') {
				if (count(wrapglob(DATADIR. IDDIR. "*.json")) >= 3+2) {
					error('ID数が規定を超えています');
				}
				// データ取得・デコード
				$id = decode(get_post('id'));
				$label = decode(get_post('label'));
				$url = decode(get_post('url'));
				$clapcnt = decode(get_post('clapcnt'));
				// ファイルチェック
				if (file_exists(DATADIR. IDDIR. $id. '.json')) error('既存のIDです。');
				// IDチェック
				if ( ! preg_match("/^[0-9a-zA-Z_-]+$/", $id)) error('IDは半角英数と_(アンダースコア)と-(ハイフン)のみ入力してください。');
				// URLチェック
				if ( ! empty($url) && ! preg_match("/^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/", $url)) error('設置元URLが不正です。');
				// 数字チェック
				if ( ! preg_match("/^\d+$/", $clapcnt)) error('拍手数は数字のみ入力してください。');
				// データセット
				$DATA = array(
					'clapcnt' => $clapcnt,
					'evalcnt' => 0,
					'evalttl' => 0,
					'evalmean' => 0.0,
					'label' => $label,
					'url' => $url,
					'config' => array(
						'on' => array(),
					),
				);
				// 書き込み
				$FN = fopen(DATADIR. IDDIR. $id. '.json', "w");
				fputs($FN, json_encode($DATA));
				fclose($FN);
				unlink($cachefile);
				// 完了後
				$_SESSION['done'] = '追加しました。';
				location($GLOBALS['script']. '?act=clapid');
			} else {
				// フォーム出力（ajax）
				id_edit_form('追加', 'add', array('id' => null, 'label' => null, 'url' => null, 'clapcnt' => 0, 'evalmean' => '0.0'));
			}
			break;
		case 'edit':
			// ▼編集
			if ($_SERVER['REQUEST_METHOD'] === 'POST') {
				// ファイル取得
				$idfile = DATADIR. IDDIR. get_post('id'). '.json';
				if (($iddata = file_read($idfile)) === null) error('該当IDが見つかりません。');
				$DATA = json_decode($iddata, true);
				// データ取得・デコード
				$label = decode(get_post('label'));
				$url = decode(get_post('url'));
				$clapcnt = decode(get_post('clapcnt'));
				// URLチェック
				if ( ! empty($url) && ! preg_match("/^(https?|ftp)(:\/\/[-_.!~*\'\(\)a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/", $url)) error('設置元URLが不正です。');
				// 数字チェック
				if ( ! preg_match("/^\d+$/", $clapcnt)) error('拍手数は数字のみ入力してください。');
				// データセット
				$DATA['clapcnt'] = $clapcnt;
				$DATA['label'] = $label;
				$DATA['url'] = $url;
				// ID別保存ファイル書き込み
				$lfh = file_lock() or die('Busy!');
					$FN = fopen($idfile, "w");
					fputs($FN, json_encode($DATA));
					fclose($FN);
					unlink($cachefile);
				file_unlock($lfh);
				// 完了後
				$_SESSION['done'] = '編集しました。';
				location($GLOBALS['script']. '?act=clapid');
			} else {
				// ファイル取得
				list($id) = get_query('id');
				if (($iddata = file_read(DATADIR. IDDIR. $id. '.json')) === null) error403();
				$DATA = json_decode($iddata, true);
				$DATA['id'] = $id;
				// フォーム出力（ajax）
				id_edit_form('編集', 'edit', $DATA);
			}
			break;
		case 'delete':
			// ▼削除
			if ($_SERVER['REQUEST_METHOD'] === 'POST') {
				// 書き込み
				$lfh = file_lock() or die('Busy!');
					foreach (get_query('id', array()) as $id) {
						unlink(DATADIR. IDDIR. $id. '.json');
					}
					unlink($cachefile);
				file_unlock($lfh);
				// 完了
				$_SESSION['done'] = '削除しました。';
				header('HTTP/1.1 200 OK');
			} else {
				error403();
			}
			break;
		case 'tag':
			// ▼タグ表示
			$id = implode('', get_query('id'));
			// ファイル取得
			$iddata = file_read(DATADIR. IDDIR. $id. '.json');
			if (is_null($iddata)) error403();
			$DATA = json_decode($iddata, true);
			$CONFIG = array_merge($GLOBALS['clapConfig'], $DATA['config']);

			// JavaScript
			$jstag = '&lt;div class="'. CLAPBUTTONPOINT. '" id="'. $id. '"&gt;&lt;/div&gt;';
			// 画像
			$root = dirname('http://'. $_SERVER['HTTP_HOST']. $_SERVER['SCRIPT_NAME']). '/'. CLAPSCRIPT;
			$imgtag = '&lt;a href="'. $root. '?mode=claping&amp;amp;id='. $id. '&amp;ajax=no"&gt;&lt;img src="'. $root. '?id='. $id. '&amp;amp;ajax=no" alt="'. $CONFIG['btnTitle']. '" title="'. $CONFIG['btnTitle']. '" /&gt;&lt;/a&gt;';

			// 出力
			echo '
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
						<h4 class="modal-title" id="modal-tool-add">タグ表示</h4>
					</div>
					<div class="modal-body">
						<p>下記のコードを任意のページに貼り付けてください。</p>
						<hr />
						<label for="javascript">JavaScript版</label>
						<textarea class="form-control" rows="5" id="javascript" onclick="this.focus();this.select()">'. $jstag. '</textarea>
						<hr />
						<label for="image">画像版</label>
						<textarea class="form-control" rows="5" id="image" onclick="this.focus();this.select()">'. $imgtag. '</textarea>
					</div>
					<div class="modal-footer">
						<button type="button" class="btn btn-default" data-dismiss="modal">閉じる</button>
					</div>
				</div>
			</div>
			';
			break;
		case 'config':
			// ▼設定
			$id = implode('', get_post('id', get_query('id')));
			// ファイル取得
			$idfile = DATADIR. IDDIR. $id. '.json';
			if (($iddata = file_read($idfile)) === null) error403();
			$DATA = json_decode($iddata, true);
			if ($_SERVER['REQUEST_METHOD'] === 'POST') {
				// 入力値取得
				$CONF = array('on' => array());
				foreach ($_POST as $name => $value) {
					if (preg_match("/^on_(.+)/", $name, $config)) {
						$CONF['on'][$config[1]] = true;
					} else {
						if (in_array($name, array('act', 'cmd'))) continue;
						$CONF[$name] = (in_array($value, array('true', 'false'))) ?
																(($value === 'true') ? true : false) :
																decode($value);
						// 定形文のみ改行を区切りに配列にする
						if ($name === 'tkb') {
							$CONF[$name] = explode("<br />", $CONF[$name]);
						}
					}
				}
				// データセット
				$DATA['config'] = $CONF;
				// 書き込み
				$lfh = file_lock() or die('Busy!');
					$FN = fopen($idfile, "w");
					fputs($FN, json_encode($DATA));
					fclose($FN);
					unlink($cachefile);
				file_unlock($lfh);
				// 完了
				$_SESSION['done'] = '設定を保存しました';
				location($GLOBALS['script']. '?act=clapid');
			} else {
				id_confg_form($id, $DATA['config']);
			}
			break;
		default:
			// ▼一覧表示
			html_header();
			content_header();

			if ( ! empty($_SESSION['done'])) {
				echo '
				<div class="alert alert-success">
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
					<p>'. $_SESSION['done']. '</p>
				</div>
				';
				unset($_SESSION['done']);
			}

			echo '
			<div class="modal fade" id="tool-modal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="tool-edit" aria-hidden="true"></div>
			<form id="clapid-form" class="clearfix">
			<table id="clapid-table" class="table table-striped table-bordered table-hover">
				<thead>
					<tr>
						<th class="tool-btn"></th>
						<th>ID</th>
						<th>ラベル</th>
						<th>設置元URL</th>
						<th>拍手数</th>
						<th>平均評価</th>
					</tr>
				</thead>
				<tbody>
				';

				$cachedata = file_read($cachefile);
				if (is_null($cachedata) || filemtime($cachefile) < time() - 60 * 3) {
					// IDファイルを個別に取得
					// ※一日のルーチン
					$CACHE = array();
					foreach (wrapglob(DATADIR. IDDIR. "*.json") as $idfile) {
						$DATA = json_decode(file_get_contents($idfile), true);
						$id = basename($idfile, '.json'); // ID
						$DATA['id'] = $id;
						id_table_tr($DATA); // 行出力
						$CACHE[] = $DATA;
					}
					// キャッシュファイル生成
					$FN = fopen($cachefile, "w");
					fputs($FN, json_encode($CACHE));
					fclose($FN);
				} else {
					// キャッシュから読み込み
					$DATA = json_decode($cachedata, true);
					foreach ($DATA as $LINE) {
						id_table_tr($LINE); // 行出力
					}
				}

				echo '
				</tbody>
			</table>
			</form>
			<div class="well">
				<ul>
					<li>一覧データは<span class="text-danger">3分毎</span>に更新されます。</li>
					<li>ラベルはIDを識別しやすくするためのものです。拍手設定の「ラベルの自動取得」を有効にしておくとtitleタグから自動的に取得されるようになります。（JavaScript版のみ）</li>
					<li>設置元URLは、拍手時にリファラーから取得した拍手ボタンを設置したページのURLです。</li>
				</ul>
			</div>
			';

			content_footer();
			html_footer();
			break;
	}
}

// ▼ IDテーブル行
function id_table_tr($DATA) {
	echo '
	<tr>
		<td class="text-center"><input type="checkbox" name="id[]" value="'. $DATA['id']. '"></td>
		<td>'. $DATA['id']. '</td>
		<td>'. $DATA['label']. '</td>
		<td style="word-break: break-all;"><a href="'. $DATA['url']. '" target="_blank">'. $DATA['url']. '</a></td>
		<td class="text-danger">'. $DATA['clapcnt']. '</td>
		<td>'. $DATA['evalmean']. ' </td>
	</tr>
	';
}

// ▼ ID編集フォーム(ajax)
function id_edit_form($title, $cmd, $INP) {
	echo <<<_HTML_
<script type="text/javascript">
$(function() {
	$("#tool-form").wrapValidate({
		rules: {
			id: "required",
			url: "url",
			clap: {
				required: true,
				digits: true
			}
		},
		messages: {
			id: "IDを入力してください",
			url: "URLが不正です",
			clap: {
				required: "拍手数を入力してください",
				digits: "拍手数は数字で入力してください"
			}
		}
	});
});
</script>
<div class="modal-dialog">
	<div class="modal-content">
		<form action="{$GLOBALS['script']}?act=clapid&cmd={$cmd}" method="post" id="tool-form" class="form-horizontal">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				<h4 class="modal-title" id="modal-tool-add">{$title}</h4>
			</div>
			<div class="modal-body">
				<div class="form-group">
					<label for="id" class="col-sm-3 control-label">ID</label>
					<div class="col-sm-9">
_HTML_;
if ($cmd === 'edit') {
	echo '
	<input type="text" name="id" value="'. $INP['id']. '" class="form-control" id="id" readonly="readonly" />
	';
} else {
	echo '
	<input type="text" name="id" value="'. $INP['id']. '" class="form-control" id="id" />
	<p class="help-block">ID名には半角英数と_（アンダースコア）-（ハイフン）が使用出来ます。</p>
	';
}
echo <<<_HTML_
					</div>
				</div>
				<div class="form-group">
					<label for="label" class="col-sm-3 control-label">ラベル</label>
					<div class="col-sm-9">
						<input type="text" name="label" value="{$INP['label']}" class="form-control" id="label" />
					</div>
				</div>
				<div class="form-group">
					<label for="url" class="col-sm-3 control-label">設置元URL</label>
					<div class="col-sm-9">
						<input type="text" name="url" value="{$INP['url']}" class="form-control" id="url" placeholder="http://" />
					</div>
				</div>
				<div class="form-group">
					<label for="clapcnt" class="col-sm-3 control-label">拍手数</label>
					<div class="col-sm-9">
						<input type="text" name="clapcnt" value="{$INP['clapcnt']}" class="form-control" id="clapcnt" />
					</div>
				</div>
				<div class="form-group">
					<label for="evalmean" class="col-sm-3 control-label">平均評価</label>
					<div class="col-sm-9">
						<p class="form-control-static">{$INP['evalmean']}</p>
					</div>
				</div>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal">キャンセル</button>
				<button type="submit" class="btn btn-primary">保存</button>
			</div>
		</form>
	</div>
</div>
_HTML_;
}

// ▼ 拍手ボタン設定フォーム(ajax)
function id_confg_form($id, $CON) {
	$CON = array_merge($GLOBALS['clapConfig'], $CON);

	// 設定有効チェックボックス
	$CONCHECK = array();
	foreach (array_keys($GLOBALS['clapConfig']) as $key) {
		$CONCHECK[$key] = '<span class="input-group-addon"><input type="checkbox" name="on_'. $key. '" value="true"';
		if (isset($CON['on'][$key]) && $CON['on'][$key] === true) $CONCHECK[$key] .= ' checked="checked"';
		$CONCHECK[$key] .= '></span>';
	}

	echo '
	<div class="modal-dialog">
		<div class="modal-content">
			<script type="text/javascript">
			$(function() {
				$("#tool-form").wrapValidate();
			});
			</script>
			<form action="'. $GLOBALS['script']. '?act=clapid&cmd=config" method="post" id="tool-form" class="form-horizontal">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
					<h4 class="modal-title" id="modal-tool-add">設定</h4>
				</div>
				<div class="modal-body">
					<input type="hidden" name="id[]" value="'. $id. '" />
					<p>この設定では拍手ボタンやメッセージ入力欄などの有無を個別に設定することが出来ます。</p>
					<p>各設定を有効にするには、必ず入力欄横のチェックボタンにチェックしてください。</p>
					<hr />
					<div class="form-group">
						<label for="label" class="col-sm-3 control-label">ラベルの自動取得</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['label']. '
								<select name="label" class="form-control" id="label">
									'. select_option(array('true' => '有効', 'false' => '無効'), $CON['label']). '
								</select>
							</div>
							<p class="help-block">有効にするとtitleタグ内の文字列をラベルとして自動的に取得します</p>
						</div>
					</div>
					<div class="form-group">
						<label for="chain" class="col-sm-3 control-label">連続拍手限度数</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['chain']. '
								<input type="text" name="chain" value="'. $CON['chain']. '" class="form-control" id="chain" />
							</div>
							<p class="help-block">0か未入力で無制限になります</p>
						</div>
					</div>
					<div class="form-group">
						<label for="numViewType" class="col-sm-3 control-label">拍手数表示形式</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['numViewType']. '
								<select name="numViewType" class="form-control" id="numViewType">
									'. select_option(array('none' => '非表示', 'total' => '合計数', 'myclap' => '自分の拍手数', 'total_myclap' => '合計数＋自分の拍手数'), $CON['numViewType']). '
								</select>
							</div>
							<p class="help-block">「自分の拍手数」を有効にする場合は必ずシステム設定の「Cookieで制御する」にチェックを入れてください</p>
						</div>
					</div>
					<div class="form-group">
						<label for="flat" class="col-sm-3 control-label">拍手ボタンデザイン</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['flat']. '
								<select name="flat" class="form-control" id="flat">
									'. select_option(array('true' => 'フラット', 'false' => 'グラデーション'), $CON['flat']). '
								</select>
							</div>
							<p class="help-block">JavaScript版のみ</p>
						</div>
					</div>
					<div class="form-group">
						<label for="btnColor" class="col-sm-3 control-label">拍手ボタンカラー</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['btnColor']. '
								<select name="btnColor" class="form-control" id="btnColor">
									'. select_option(array('default' => '白', 'primary' => '青', 'info' => '水色', 'success' => '緑', 'warning' => '黄', 'danger' => '赤'), $CON['btnColor']). '
								</select>
							</div>
							<p class="help-block">JavaScript版のみ</p>
						</div>
					</div>
					<div class="form-group">
						<label for="btnType" class="col-sm-3 control-label">拍手ボタン表示形式</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['btnType']. '
								<select name="btnType" class="form-control" id="btnType">
									'. select_option(array('normal' => 'ノーマル', 'arrow' => '吹き出し付き'), $CON['btnType']). '
								</select>
							</div>
							<p class="help-block">JavaScript版のみ</p>
						</div>
					</div>
					<div class="form-group">
						<label for="animation" class="col-sm-3 control-label">アニメーション</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['animation']. '
								<select name="animation" class="form-control" id="animation">
									'. select_option(array('true' => '有効', 'false' => '無効'), $CON['animation']). '
								</select>
							</div>
							<p class="help-block">拍手時に数字加算アニメーションを追加します（JavaScript版のみ）</p>
						</div>
					</div>
					<div class="form-group">
						<label for="btnTitle" class="col-sm-3 control-label">拍手タイトル</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['btnTitle']. '
								<input type="text" name="btnTitle" value="'. $CON['btnTitle']. '" class="form-control" id="btnTitle" />
							</div>
							<p class="help-block">拍手ボタンにマウスを重ねた時に表示されるタイトル、もしくはテンプレートを使用した場合のtitleタグ内のタイトル名です</p>
						</div>
					</div>
					<div class="form-group">
						<label for="btnText" class="col-sm-3 control-label">拍手ボタン内テキスト</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['btnText']. '
								<input type="text" name="btnText" value="'. $CON['btnText']. '" class="form-control" id="btnText" />
							</div>
						</div>
					</div>
					<div class="form-group">
						<label for="thanksClapMessage" class="col-sm-3 control-label">拍手お礼メッセージ</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['thanksClapMessage']. '
								<textarea name="thanksClapMessage" class="form-control" id="thanksClapMessage" rows="5">'. preg_replace("/<br \/>/", "\n", $CON['thanksClapMessage']). '</textarea>
							</div>
						</div>
					</div>
					<div class="form-group">
						<label class="col-sm-3 control-label">入力欄</label>
						<div class="col-sm-9">
							<div class="form-control-static">
								<label>
									<input type="hidden" name="inputName" value="false" disabled="disabled" />
									<input type="checkbox" name="inputName" value="true"'. checkbox_checked($CON['inputName']). '> 「名前」入力欄を表示する
								</label><br />
								<label>
									<input type="hidden" name="inputEval" value="false" disabled="disabled" />
									<input type="checkbox" name="inputEval" value="true"'. checkbox_checked($CON['inputEval']). '> 「評価」入力欄を表示する
								</label><br />
								<label>
									<input type="hidden" name="inputTkb" value="false" disabled="disabled" />
									<input type="checkbox" name="inputTkb" value="true"'. checkbox_checked($CON['inputTkb']). '> 「定形文」入力欄を表示する
								</label><br />
								<label>
									<input type="hidden" name="inputMsg" value="false" disabled="disabled" />
									<input type="checkbox" name="inputMsg" value="true"'. checkbox_checked($CON['inputMsg']). '> 「メッセージ」入力欄を表示する
								</label>
							</div>
						</div>
					</div>
					<div class="form-group">
						<label for="tkb" class="col-sm-3 control-label">定形文</label>
						<div class="col-sm-9">
							<div class="input-group">
								'. $CONCHECK['tkb']. '
								<textarea name="tkb" class="form-control" id="tkb" rows="5">'. implode("\n", $CON['tkb']). '</textarea>
							</div>
							<p class="help-block">改行で区切ってください</p>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal">閉じる</button>
					<button type="submit" class="btn btn-primary">保存</button>
				</div>
			</form>
		</div>
	</div>
	';
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ チャート
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function chart() {
	// 時次
	$TIMERY = array(
		'0' => 0, '1' => 0, '2' => 0, '3' => 0, '4' => 0, '5' => 0, '6' => 0, '7' => 0, '8' => 0, '9' => 0, '10' => 0, '11' => 0, '12' => 0, '13' => 0, '14' => 0, '15' => 0, '16' => 0, '17' => 0, '18' => 0, '19' => 0, '20' => 0, '21' => 0, '22' => 0, '23' => 0,
	);
	$todayfile = DATADIR. DATEDIR. date("Y/m-d"). '.dat';
	$total = 0;
	if (file_exists($todayfile)) {
		foreach (file($todayfile) as $line) {
			list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", rtrim($line, "\n"));
			$TIMERY[date("G", $time)] += $chain;
			$total += $chain;
		}
	}
	$timery = '';
	foreach ($TIMERY as $hour => $clap) {
		$par = (($clap != 0) && ($total != 0)) ? floor(($clap / $total) * 100) : 0;
		$timery .= '
		<tr>
			<td>'. sprintf("%02d", $hour). ':00</td>
			<td>
				<div class="progress">
					<div class="progress-bar" role="progressbar" aria-valuenow="'. $par. '" aria-valuemin="0" aria-valuemax="100" style="width: '. $par. '%;">'. $clap. '</div>
				</div>
			</td>
		</tr>
		';
	}

	// 日次・月次
	$DIARY = array();
	$MONTH = array();
	$diaryjson = DATADIR. DATEDIR. 'diary.json';
	$monthjson = DATADIR. DATEDIR. 'month.json';
	if ( ! file_exists($diaryjson) or (file_exists($diaryjson) && strtotime(date('Y-m-d H:i', filemtime($diaryjson)). ' +1 day') < time())) {
		$stttime = time();
		$endtime = strtotime(date('Y-m-d').' -1 year');
		for ($t = $stttime; $t >= $endtime; $t = strtotime(date('Y-m-d', $t).' -1 month')) {
			$monthclap = 0;
			foreach (wrapglob(DATADIR. DATEDIR. date('Y/m-', $t). '*.dat') as $file) {
				$dayclap = 0;
				foreach (file($file) as $line) {
					list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", rtrim($line, "\n"));
					$dayclap += $chain;
				}
				preg_match('/^.+?(\d+)\/(\d+)-(\d+)\.dat$/', $file, $date);
				$_date = $date[1]. '-'. $date[2]. '-'. $date[3];
				if (strtotime($_date .' +1 week') > time()) {
					$DIARY[] = array(
						'day' => $_date,
						'clap' => $dayclap,
					);
				}
				$monthclap += $dayclap;
			}
			$MONTH[] = array(
				'month' => date('Y-m', $t),
				'clap' => $monthclap,
			);
		}
		$diary = json_encode($DIARY);
		$month = json_encode($MONTH);
		// jsonファイル生成
		$FN = fopen($diaryjson, "w");
		fputs($FN, $diary);
		fclose($FN);
		$FN = fopen($monthjson, "w");
		fputs($FN, $month);
		fclose($FN);
	} else {
		$diary = file_get_contents($diaryjson);
		$month = file_get_contents($monthjson);
	}

	html_header();
	content_header();

	echo <<< _HTML_
<div class="chart-caption">時次（本日付け）</div>
<table class="table table-condensed table-chart">
	<thead>
		<tr>
			<td width="5%">時刻</td>
			<td width="95%">拍手数</td>
		</tr>
	</thead>
	<tbody>
	{$timery}
	</tbody>
</table>
<hr />
<div class="row">
	<div class="col-md-12">
		<div class="item-box">
			<div class="chart-caption">日次（本日より一週間以内の拍手）</div>
			<div class="chart" id="daily"></div>
			<script type="text/javascript">
			new Morris.Line({
				element: 'daily',
				data: {$diary},
				xkey: 'day',
				ykeys: ['clap'],
				labels: ['拍手数']
			});
			</script>
		</div>
	</div>
</div>
<br />
<div class="row">
	<div class="col-md-12">
		<div class="item-box">
			<div class="chart-caption">月次</div>
			<div class="chart" id="monthly"></div>
			<script type="text/javascript">
			new Morris.Line({
			  element: 'monthly',
			  data: {$month},
			  xkey: 'month',
			  ykeys: ['clap'],
			  labels: ['拍手数']
			});
			</script>
		</div>
	</div>
</div>
_HTML_;

	content_footer();
	html_footer();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 基本拍手設定
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clapconfig() {
	if ($_SERVER['REQUEST_METHOD'] === 'POST') {
		foreach ($_POST as $name => $value) {
			if ($name === 'mode') continue;
			// 入力値セット
			$CON[$name] = (in_array($value, array('true', 'false'))) ?
													(($value === 'true') ? true : false) :
													decode($value);
			// 定形文を区切りに配列にする
			if ($name === 'tkb') {
				$CON[$name] = explode("<br />", $CON[$name]);
			}
		}
		$GLOBALS['clapConfig'] = $CON;
		$GLOBALS['system'] = array(
			'varsion' => VARSION,
			'cookieCTRL' => $GLOBALS['system']['cookieCTRL'],
		);
		// ファイルロック実行
		$lfh = file_lock() or die('Busy!');
		// ファイルパス（定数で指定）
		$GLOBALS['path'] = array(
			'mwhgPhp' => CLAPSCRIPT,
			'dataDir' => DATADIR,
			'idDir' => IDDIR,
			'cssDir' => CSSDIR,
			'bootstrapCss' => BSCCSS,
			'bootstrapThemeCss' => BSTCCSS,
			'jsDir' => JSDIR,
			'bootstrapJs' => BSCJS,
			'imgDir' => IMGDIR,
			'loadingImg' => LOADINGIMG,
			'star1Img' => STARIMG1,
			'star2Img' => STARIMG2,
			'star3Img' => STARIMG3,
			'closeImg' => CLOSEIMG,
			'closeHoverImg' => CLOSEHIMG,
		);
		unset($GLOBALS['script']);
		// 基本設定ファイル書き込み
		$FN = fopen(DATADIR. CONFIGJSON, "w");
		fputs($FN, json_encode($GLOBALS));
		fclose($FN);
		// ファイルロック解除
		file_unlock($lfh);
		// 完了
		$_SESSION['done'] = '設定を保存しました';
		location($GLOBALS['script']. '?act=clapconfig');
	}

	html_header();
	content_header();

	echo '
	<div class="row">
		<div class="col-md-6 col-md-offset-3">
			';
			if ( ! empty($_SESSION['done'])) {
				echo '
				<div class="alert alert-success">
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
					<p>'. $_SESSION['done']. '</p>
				</div>
				';
				unset($_SESSION['done']);
			}
			echo '
			<script type="text/javascript">
			$(function() {
				$("#configform").wrapValidate();
			});
			</script>
			<form action="'. $GLOBALS['script']. '?act=clapconfig" method="post" id="configform" class="form-horizontal">
				<legend>基本拍手設定</legend>
				<p>この設定は、個別拍手設定が未設定のIDに対してデフォルトの設定を決めることができます。</p>
				<div class="form-group">
					<label for="label" class="col-sm-4 control-label">ラベルの自動取得</label>
					<div class="col-sm-8">
						<select name="label" class="form-control" id="label">
							'. select_option(array('true' => '有効', 'false' => '無効'), $GLOBALS['clapConfig']['label']). '
						</select>
						<p class="help-block">有効にするとtitleタグ内の文字列をラベルとして自動的に取得します</p>
					</div>
				</div>
				<div class="form-group">
					<label for="chain" class="col-sm-4 control-label">連続拍手限度数</label>
					<div class="col-sm-8">
						<input type="text" name="chain" value="'. $GLOBALS['clapConfig']['chain']. '" class="form-control" id="chain" />
						<p class="help-block">0か未入力で無制限になります</p>
					</div>
				</div>
				<div class="form-group">
					<label for="numViewType" class="col-sm-4 control-label">拍手数表示形式</label>
					<div class="col-sm-8">
						<select name="numViewType" class="form-control" id="numViewType">
							'. select_option(array('none' => '非表示', 'total' => '合計数', 'myclap' => '自分の拍手数', 'total_myclap' => '合計数＋自分の拍手数'), $GLOBALS['clapConfig']['numViewType']). '
						</select>
						<p class="help-block">「自分の拍手数」を有効にする場合は必ずシステム設定の「Cookieで制御する」にチェックを入れてください</p>
					</div>
				</div>
				<div class="form-group">
					<label for="flat" class="col-sm-4 control-label">拍手ボタンデザイン</label>
					<div class="col-sm-8">
						<select name="flat" class="form-control" id="flat">
							'. select_option(array('true' => 'フラット', 'false' => 'グラデーション'), $GLOBALS['clapConfig']['flat']). '
						</select>
						<p class="help-block">JavaScript版のみ</p>
					</div>
				</div>
				<div class="form-group">
					<label for="btnColor" class="col-sm-4 control-label">拍手ボタンカラー</label>
					<div class="col-sm-8">
						<select name="btnColor" class="form-control" id="btnColor">
							'. select_option(array('default' => '白', 'primary' => '青', 'info' => '水色', 'success' => '緑', 'warning' => '黄', 'danger' => '赤'), $GLOBALS['clapConfig']['btnColor']). '
						</select>
						<p class="help-block">JavaScript版のみ</p>
					</div>
				</div>
				<div class="form-group">
					<label for="btnType" class="col-sm-4 control-label">拍手ボタン表示形式</label>
					<div class="col-sm-8">
						<select name="btnType" class="form-control" id="btnType">
							'. select_option(array('normal' => 'ノーマル', 'arrow' => '吹き出し付き'), $GLOBALS['clapConfig']['btnType']). '
						</select>
						<p class="help-block">JavaScript版のみ</p>
					</div>
				</div>
				<div class="form-group">
					<label for="animation" class="col-sm-4 control-label">アニメーション</label>
					<div class="col-sm-8">
						<select name="animation" class="form-control" id="animation">
							'. select_option(array('true' => '有効', 'false' => '無効'), $GLOBALS['clapConfig']['animation']). '
						</select>
						<p class="help-block">拍手時に数字加算アニメーションを追加します（JavaScript版のみ）</p>
					</div>
				</div>
				<div class="form-group">
					<label for="btnTitle" class="col-sm-4 control-label">拍手タイトル</label>
					<div class="col-sm-8">
						<input type="text" name="btnTitle" value="'. $GLOBALS['clapConfig']['btnTitle']. '" class="form-control" id="btnTitle" />
						<p class="help-block">拍手ボタンにマウスを重ねた時に表示されるタイトル、もしくはテンプレートを使用した場合のtitleタグ内のタイトル名です</p>
					</div>
				</div>
				<div class="form-group">
					<label for="btnText" class="col-sm-4 control-label">拍手ボタン内テキスト</label>
					<div class="col-sm-8">
						<input type="text" name="btnText" value="'. $GLOBALS['clapConfig']['btnText']. '" class="form-control" id="btnText" />
					</div>
				</div>
				<div class="form-group">
					<label for="thanksClapMessage" class="col-sm-4 control-label">拍手お礼メッセージ</label>
					<div class="col-sm-8">
						<textarea name="thanksClapMessage" class="form-control" id="thanksClapMessage" rows="5">'. preg_replace("/<br \/>/", "\n", $GLOBALS['clapConfig']['thanksClapMessage']). '</textarea>
					</div>
				</div>
				<div class="form-group">
					<label class="col-sm-4 control-label">入力欄</label>
					<div class="col-sm-8">
						<div class="form-control-static">
							<label>
								<input type="hidden" name="inputName" value="false" disabled="disabled" />
								<input type="checkbox" name="inputName" value="true"'. checkbox_checked($GLOBALS['clapConfig']['inputName']). '> 「名前」入力欄を表示する
							</label>
							<br />
							<label>
								<input type="hidden" name="inputEval" value="false" disabled="disabled" />
								<input type="checkbox" name="inputEval" value="true"'. checkbox_checked($GLOBALS['clapConfig']['inputEval']). '> 「評価」入力欄を表示する</label>
							<br />
							<label>
								<input type="hidden" name="inputTkb" value="false" disabled="disabled" />
								<input type="checkbox" name="inputTkb" value="true"'. checkbox_checked($GLOBALS['clapConfig']['inputTkb']). '> 「定形文」入力欄を表示する
							</label>
							<br />
							<label>
								<input type="hidden" name="inputMsg" value="false" disabled="disabled" />
								<input type="checkbox" name="inputMsg" value="true"'. checkbox_checked($GLOBALS['clapConfig']['inputMsg']). '> 「メッセージ」入力欄を表示する
							</label>
						</div>
					</div>
				</div>
				<div class="form-group">
					<label for="tkb" class="col-sm-4 control-label">定形文</label>
					<div class="col-sm-8">
						<textarea name="tkb" class="form-control" id="tkb" rows="5">'. implode("\n", $GLOBALS['clapConfig']['tkb']). '</textarea>
						<p class="help-block">改行で区切ってください</p>
					</div>
				</div>
				<div class="form-group">
					<div class="col-sm-offset-4 col-sm-8">
						<button type="submit" class="btn btn-primary">保存</button>
					</div>
				</div>
			</form>
		</div>
	</div>
	';

	content_footer();
	html_footer();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ システム設定
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function systemconfig() {
	if ($_SERVER['REQUEST_METHOD'] === 'POST') {
		foreach ($_POST as $name => $value) {
			if ($name === 'mode') continue;
			// 入力値セット
			$CON[$name] = (in_array($value, array('true', 'false'))) ?
													(($value === 'true') ? true : false) :
													decode($value);
			// アクセス制限のみ改行を区切りに配列にする
			if ($name === 'denyHosts') {
				$CON[$name] = explode("<br />", $CON[$name]);
			}
		}
		// ファイルロック実行
		$lfh = file_lock() or die('Busy!');
		// システム設定ファイル書き込み
		$FN = fopen(DATADIR. SYSTEMJSON, "w");
		fputs($FN, json_encode($CON));
		fclose($FN);
		// 基本設定ファイルにはプログラムバージョンとCookie使用可否設定のみ保存する
		$GLOBALS['system'] = array(
			'varsion' => VARSION,
			'cookieCTRL' => $CON['cookieCTRL'],
		);
		unset($GLOBALS['script']);
		// 基本設定ファイル書き込み
		$FN = fopen(DATADIR. CONFIGJSON, "w");
		fputs($FN, json_encode($GLOBALS));
		fclose($FN);
		// ファイルロック解除
		file_unlock($lfh);
		// 完了
		$_SESSION['done'] = '設定を保存しました';
		location($GLOBALS['script']. '?act=systemconfig');
	}

	html_header();
	content_header();

	echo '
	<div class="row">
		<div class="col-md-6 col-md-offset-3">
			';
			if ( ! empty($_SESSION['done'])) {
				echo '
				<div class="alert alert-success">
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
					<p>'. $_SESSION['done']. '</p>
				</div>
				';
				unset($_SESSION['done']);
			}
			echo '
			<script type="text/javascript">
			$(function() {
				$("#configform").wrapValidate();
			});
			</script>
			<form action="'. $GLOBALS['script']. '?act=systemconfig" method="post" id="configform" class="form-horizontal">
				<legend>システム設定</legend>
				<div class="form-group">
					<label for="mailAddress" class="col-sm-4 control-label">メールアドレス</label>
					<div class="col-sm-8">
						<input type="text" name="mailAddress" value="'. $GLOBALS['system']['mailAddress']. '" class="form-control" id="mailAddress" />
						<p class="help-block">メールアドレスを設定することで拍手後のメッセージ等送信時に通知メールを受け取れます</p>
					</div>
				</div>
				<div class="form-group">
					<label class="col-sm-4 control-label">メール通知フラグ</label>
					<div class="col-sm-8">
						<div class="form-control-static">
							<label>
								<input type="hidden" name="mailFlgName" value="false" disabled="disabled" />
								<input type="checkbox" name="mailFlgName" value="true"'. checkbox_checked($GLOBALS['system']['mailFlgName']). '> 「名前」が入力されたら通知
							</label>
							<br />
							<label>
								<input type="hidden" name="mailFlgEval" value="false" disabled="disabled" />
								<input type="checkbox" name="mailFlgEval" value="true"'. checkbox_checked($GLOBALS['system']['mailFlgEval']). '> 「評価」が入力されたら通知</label>
							<br />
							<label>
								<input type="hidden" name="mailFlgTkb" value="false" disabled="disabled" />
								<input type="checkbox" name="mailFlgTkb" value="true"'. checkbox_checked($GLOBALS['system']['mailFlgTkb']). '> 「定形文」が入力されたら通知
							</label>
							<br />
							<label>
								<input type="hidden" name="mailFlgMsg" value="false" disabled="disabled" />
								<input type="checkbox" name="mailFlgMsg" value="true"'. checkbox_checked($GLOBALS['system']['mailFlgMsg']). '> 「メッセージ」が入力されたら通知
							</label>
						</div>
						<p class="help-block">メールで通知する場合に、その通知条件となる設定です。ひとつでも当てはまればメールが送信されます</p>
					</div>
				</div>
				<div class="form-group">
					<label for="getReferer" class="col-sm-4 control-label">リファラーからURLを取得する</label>
					<div class="col-sm-8">
						<select name="getReferer" class="form-control" id="getReferer">
							'. select_option(array('true' => '有効', 'false' => '無効'), $GLOBALS['system']['getReferer']). '
						</select>
						<p class="help-block">拍手IDの設置元URL設定に使用します</p>
					</div>
				</div>
				<div class="form-group">
					<label for="cookieCTRL" class="col-sm-4 control-label">Cookie制御</label>
					<div class="col-sm-8">
						<select name="cookieCTRL" class="form-control" id="cookieCTRL">
							'. select_option(array('true' => '有効', 'false' => '無効'), $GLOBALS['system']['cookieCTRL']). '
						</select>
						<p class="help-block">連続拍手やアクセス制限に使用します</p>
					</div>
				</div>
				<div class="form-group">
					<label for="hostCTRL" class="col-sm-4 control-label">IP/ホスト制御</label>
					<div class="col-sm-8">
						<select name="hostCTRL" class="form-control" id="hostCTRL">
							'. select_option(array('true' => '有効', 'false' => '無効'), $GLOBALS['system']['hostCTRL']). '
						</select>
						<p class="help-block">連続拍手やアクセス制限に使用します</p>
					</div>
				</div>
				<div class="form-group">
					<label for="denyHosts" class="col-sm-4 control-label">アクセス制限</label>
					<div class="col-sm-8">
						<textarea name="denyHosts" class="form-control" id="denyHosts" rows="5">'. implode("\n", (array) $GLOBALS['system']['denyHosts']). '</textarea>
						<p class="help-block">改行で区切ってください。アスタリスク(*)が使用可能です。</p>
					</div>
				</div>
				<div class="form-group">
					<div class="col-sm-offset-4 col-sm-8">
						<button type="submit" class="btn btn-primary">保存</button>
					</div>
				</div>
			</form>
		</div>
	</div>
	';

	content_footer();
	html_footer();
}


//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ドキュメントヘッダー
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function html_header() {
	header('Content-Type: text/html; charset: utf-8');
	$def = new define_parse();
	echo <<< _HTML_
<!DOCTYPE html>
<html lang="ja">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>まいるどWEB拍手ぐれーと</title>
	<link type="text/css" rel="stylesheet" href="{$def->get('CSSDIR')}{$def->get('BOOTSTRAPCSS')}" />
	<link type="text/css" rel="stylesheet" href="{$def->get('CSSDIR')}{$def->get('DATEPICKERCSS')}" />
	<link type="text/css" rel="stylesheet" href="{$def->get('CSSDIR')}{$def->get('MORRISCSS')}" />
	<link type="text/css" rel="stylesheet" href="{$def->get('CSSDIR')}{$def->get('DATATABLECSS')}" />
	<link type="text/css" rel="stylesheet" href="{$def->get('CSSDIR')}{$def->get('ADMINCSS')}" />
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('JQUERYJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('REQHEALJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('BOOTSTRAPJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('DATEPICKERJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('DATEPICKERJAJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('MORRISJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('VALIDATEJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('DATATABLEJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('DATATABLEBSJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('SCRIPTJS')}"></script>
	<script type="text/javascript" src="{$def->get('JSDIR')}{$def->get('ADMINJS')}"></script>
	<!--[if lt IE 9]>
	<script type="text/javascript" src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<script type="text/javascript" src="http://ie7-js.googlecode.com/svn/version/2.1(beta4)/IE9.js"></script>
	<![endif]-->
</head>
<body>
_HTML_;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ドキュメントフッター
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function html_footer() {
		echo <<< _HTML_
</body>
</html>
_HTML_;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ コンテンツヘッダー
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function content_header() {
	$act = get_query('act');
	echo '
<div id="wrapper">
	<nav class="navbar navbar-default navbar-static-top board-navbar" role="navigation">
		<div class="container">
			<div class="navbar-header">
				<button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbar-collapse-menu">
					<span class="sr-only">メニュー</span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
				</button>
				<a class="navbar-brand" href="'. $GLOBALS['script']. '">まいるどWEB拍手ぐれーと</a>
			</div>
			<div class="collapse navbar-collapse" id="navbar-collapse-menu">
				<ul class="nav navbar-nav">
					<li'. ((empty($act) || $act === 'idlist') ? ' class="active"' : ''). '><a href="'. $GLOBALS['script']. '?"><span class="glyphicon glyphicon-comment"></span> 拍手一覧</a></li>
					<li'. (($act === 'clapid') ? ' class="active"' : ''). '><a href="'. $GLOBALS['script']. '?act=clapid"><span class="glyphicon glyphicon-flag"></span> ID一覧</a></li>
					<li'. (($act === 'chart') ? ' class="active"' : ''). '><a href="'. $GLOBALS['script']. '?act=chart"><span class="glyphicon glyphicon-stats"></span> チャート</a></li>
					<li class="dropdown">
						<a href="#" class="dropdown-toggle" data-toggle="dropdown"><span class="glyphicon glyphicon-cog"></span> 設定 <b class="caret"></b></a>
						<ul class="dropdown-menu">
							<li'. (($act === 'clapconfig') ? ' class="active"' : ''). '><a href="'. $GLOBALS['script']. '?act=clapconfig"><span class="glyphicon glyphicon-comment"></span> 基本拍手設定</a></li>
							<li'. (($act === 'systemconfig') ? ' class="active"' : ''). '><a href="'. $GLOBALS['script']. '?act=systemconfig"><span class="glyphicon glyphicon-wrench"></span> システム設定</a></li>
						</ul>
					</li>
				</ul>
				<ul class="nav navbar-nav navbar-right">
					<li'. (($act === 'logout') ? ' class="active"' : ''). '><a href="'. $GLOBALS['script']. '?mode=logout"><span class="glyphicon glyphicon-log-out"></span> ログアウト</a></li>
				</ul>
			</div>
		</div>
	</nav>
	<div id="center" class="container">
	';
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ コンテンツフッター
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function content_footer() {
	$def = new define_parse();
		echo <<< _HTML_
	</div>
	<div id="push"></div>
</div>
<footer id="footer">
	<div class="container">
		<span id="copyright"><a href="http://mcgi.jpn.ch/">まいるどWEB拍手ぐれーと ver{$def->get('VARSION')}</a></span>
	</div>
</footer>
_HTML_;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ログイン
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function login_form() {
	$error = get_session('error');
	$errormsg = '';
	if ( ! is_null($error)) {
		$errormsg = '<div class="alert alert-danger"><p>'. $error. '</p></div>';
		unset($_SESSION['error']);
	}

	html_header();

	echo <<< _HTML_
<div class="item-box centering" id="login">
	<h4>管理者ログイン</h4>
	<hr />
	{$errormsg}
	<form action="{$GLOBALS['script']}?" method="post">
		<input type="hidden" name="mode" value="login">
		<div class="input-group">
			<span class="input-group-addon"><span class="glyphicon glyphicon-lock"></span></span>
			<input type="password" name="password" value="" placeholder="パスワード" class="form-control" />
		</div>
		<button type="submit" class="btn btn-primary btn-block submit"><span class="glyphicon glyphicon-log-in"></span> ログイン</button>
	</form>
</div>
_HTML_;

	html_footer();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ エラー
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function error($error) {
	html_header();

	echo <<< _HTML_
<div class="item-box centering">
	<h4 class="text-danger">エラー</h4>
	<hr />
	<div class="alert alert-danger">
		<p>{$error}</p>
	</div>
	<a href="JavaScript:history.back();" class="btn btn-default">&laquo; 前のページに戻る</a>
</div>
_HTML_;

	html_footer();
	exit;
}

?>
