$(function() {
	// ツールチップ
	// $('.timeline > li > .timeline-point > .label').tooltip();

	// タブ
	// $('.nav-tabs > a').click(function() {
	// 	$(this).tab('show');
	// });

	// チェックボックス未チェック対策
	// $('#configform').on('submit', 'form', function() {
	// 	$(this).find('input[type="checkbox"]:checked').each(function() {
	// 		$(this).prev('input[type="hidden"]').prop('disabled', true);
	// 	});
	// });
	// validateで実装

	// 日付ピッカー
	$('input.date').	datepicker({
		orientation: 'bottom left',
		todayHighlight: true,
		language: 'ja'
	});

	// IDリスト
	var aSelected = [];
	$('#clapid-table').dataTable({
		"aaSorting": [],
		"aoColumnDefs": [{
			"bSortable": false,
			"aTargets": [ 'tool-btn' ]
		}],
		"aoColumns": [ 
			{ "bSearchable" : true, sWidth: '4%' },
			{ "bSearchable" : false, sWidth: '18%' },
			{ "bSearchable" : true, sWidth: '27%' },
			{ "bSearchable" : true, sWidth: '31%' },
			{ "bSearchable" : true, sWidth: '10%' },
			{ "bSearchable" : true, sWidth: '10%' }
		]
	}).on('click', 'tbody > tr > td > input[type="checkbox"]', function() {
		var id = $(this).val();
		var index = $.inArray(id, aSelected);

		if (index === -1) {
			aSelected.push(id);
			$(this).prop('checked', true);
		} else {
			aSelected.splice(index, 1);
			$(this).prop('checked', false);
		}

		var toolbar = $('.toolbar');
		if (aSelected.length === 0) {
			toolbar.find('button:not(.tool-add, tool-delete)').addClass('disabled');
		} else if (aSelected.length > 0) {
			toolbar.find('button:not(.tool-add, tool-delete)').removeClass('disabled');
			if (aSelected.length > 1) {
				toolbar.find('.tool-edit, .tool-config, .tool-tag').addClass('disabled');
			}
		}

		$(this).parents('tr').toggleClass('info');
	});

	// ツールバー
	$('.toolbar').html('<div class="btn-group">' +
			'<button type="button" class="btn btn-default tool-add" data-action="add"><i class="glyphicon glyphicon-plus"></i> 追加</button>' +
			'<button type="button" class="btn btn-default disabled tool-edit" data-action="edit"><i class="glyphicon glyphicon-pencil"></i> 編集</button>' +
			'<button type="button" class="btn btn-default disabled tool-delete" data-action="delete"><i class="glyphicon glyphicon-trash"></i> 削除</button>' +
			'<button type="button" class="btn btn-default disabled tool-config" data-action="config"><i class="glyphicon glyphicon-cog"></i> 設定</button>' +
			'<button type="button" class="btn btn-default disabled tool-tag" data-action="tag"><i class="glyphicon glyphicon-file"></i> タグ表示</button>' +
		'</div>' +
		'<div class="btn-group">' +
			'<div class="loading hidden"></div>' +
		'</div>');
	$('.toolbar').on('click', 'button', function() {
		var loading = $('.toolbar').find('.loading');
		var formStr = $('#clapid-form').serialize();
		var action = $(this).data('action');

		if ( ! $(this).hasClass('disabled') && loading.hasClass('hidden')) {
			// ajax初期設定
			$.ajaxSetup({
				url: "admin.php?" + formStr,
				dataType: 'html',
				timeout: 10000,
				cache : false,
				data: {
					act: 'clapid',
					cmd: action
				}
			});

			if (action != 'delete') {
				loading.removeClass('hidden');

				// 追加・編集・設定
				$.ajax({
					type: 'GET'
				}).
				always(function() {
					loading.addClass('hidden');
				}).
				done(function(data) {
					$('#tool-modal').html(data).modal('show');
					input_group_check();
				}).
				fail(function() {
					alert('エラーが発生しました。トップページに戻って最初からやり直してください。');
				});
			} else {
				// 削除
				if (confirm("選択したIDを削除します。\n\nよろしいですか？")) {
					loading.removeClass('hidden');

					$.ajax({
						type: 'POST'
					}).
					fail(function() {
						alert('エラーが発生しました。最初からやり直してください。');
					}).
					always(function() {
						location.href = "admin.php?act=clapid";
					});
				}
			}
		}
	});

	// インプットグループ無効⇔有効
	$('body').on('click', '.input-group-addon > input[type="checkbox"]', function() {
			input_group_disabled($(this));
	});
	function input_group_check() {
		$('.input-group-addon > input[type="checkbox"]').each(function() {
			input_group_disabled($(this));
		});
	}
	function input_group_disabled(checkbox) {
		var igObj = checkbox.closest('.input-group').children('select, input, textarea');
		if (checkbox.prop('checked')) {
			igObj.prop('disabled', false).removeClass('disabled');
		} else {
			igObj.prop('disabled', true).addClass('disabled');
		}
	}
});