;(function($) {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// ■ ユーザー設定 ■ ////
// ★PHP設置ディレクトリURL（絶対パス指定）
var rootUrl = "http://homepage/cgi-bin/mwhg/";

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//■ 以下スクリプト ■//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	var jsonLoad = false;

	$(function() {
		var system, config, path;
		$.Deferred().
		resolve().
		then(function() {
			// 設定ファイル読み込み
			return $.ajax({ url: rootUrl + 'data/config.json', dataType: 'json', cache : false });
		}).
		fail(function(xhr, status, error) {
			console.log('failed: ' + status + ' ' + xhr.status + ' ' + xhr.statusText);
		}).
		done(function(data) {
			system = data.system;
			config = data.clapConfig;
			path = data.path;
			// CSSファイル読み込み
			var head = $('head');
			head.prepend('<link><link>');
			head.children(':first').
				prop({
					rel: 'stylesheet', type: 'text/css',
					href: rootUrl + path.cssDir + path.bootstrapCss
				}).
			next().
				prop({
					rel: 'stylesheet', type: 'text/css',
					href: rootUrl + path.cssDir + path.bootstrapThemeCss
				});
		}).
		then(function() {
			// Bootstrap JSファイル読み込み
			return $.ajax({url: rootUrl + path.jsDir + path.bootstrapJs, dataType: 'script' });
		}).
		fail(function(xhr, status, error) {
			console.log('failed: ' + status + ' ' + xhr.status + ' ' + xhr.statusText);
		}).
		done(function() {
			// Cookie読み込み
			var cookie = getCookie();

			// ajax初期設定
			$.ajaxSetup({
				url: rootUrl + path.mwhgPhp,
				type: 'POST',
				dataType: 'json',
				timeout: 10000,
				cache : false,
			});

			$('div.mwhg_point').
				// ローディング画像表示
				html('<img src="' + rootUrl + path.imgDir + path.loadingImg + '" class="mwhg_loading" />').
				///////// 拍手データ読み込み ////////////////////////////////////////////////////////////////////////////////////////////
				each(function() {
					var obj = $(this);
					var clapId = obj.prop('id');

					// IDチェック
					if ( ! clapId.match(/^[0-9a-zA-Z_-]+$/i)) {
						// ローディング画像非表示
						obj.children('img.mwhg_loading').hide().
						end()	.prepend('<span class="text-danger">[使用出来ないID名です]</span>');
						return true;
					}

					// オプション
					var op = $.extend({}, config, obj.data('op'));

					// 読み込み形式
					var clapBtnAjax;
					if (jsonLoad) {
						clapBtnAjax = {
							url: rootUrl + path.dataDir + path.idDir + clapId + '.json'
						};
					} else {
						clapBtnAjax = {
							url: rootUrl + path.mwhgPhp,
							data: {
								'id' : clapId
							}
						};
					}

					// 読み込み実行
					var clapData;
					$.ajax(clapBtnAjax).
					fail(function(xhr, status, error) {
						// console.log("failed: " + status + ' ' + xhr.status + ' ' + xhr.statusText);
						// obj.prepend('<span class="text-danger">[読み込みに失敗しました]</span>');
						clapData = {
							'clapcnt' : 0,
							'evalcnt' : 0,
							'evalttl' : 0,
							'evalmean' : 0.0,
						};
					}).
					done(function(data, status, xhr) {
						clapData = data;
						op = $.extend({}, config, obj.data('op'), data.config);
					}).
					always(function() {
						// ローディング画像非表示
						obj.children('img.mwhg_loading').hide();

						// ユーザー個別拍手数
						var userClapCount = (cookie[clapId]) ? cookie[clapId] : 0;

						// 拍手数表示形式
						var clapCount;
						if (system.cookieCTRL && op.numViewType == 'myclap') {
							clapCount = userClapCount;
						} else if (system.cookieCTRL && op.numViewType == 'total_myclap') {
							clapCount = clapData.clapcnt - (((clapData.clapcnt - userClapCount) > 0) ? userClapCount : clapData.clapcnt);
							if (userClapCount > 0) clapCount += ' + ' + userClapCount;
						} else {
							// total
							clapCount = clapData.clapcnt;
						}

						// ボタン形成
						var clpbtn =
							'<span title="'+ op.btnTitle + '">' +
								'<button class="mwhg_clapbutton' + ((op.flat) ? '' : ' gradation') + ' btn btn-' + op.btnColor +' btn-xs">';

								if (op.numViewType != 'none') {
									if (op.btnType == 'arrow') {
										clpbtn +=
											op.btnText + ' </button>' +
											'<div class="mwhg_arrow">' +
												'<span class="inner"><span class="count">' + clapCount + '</span></span>' +
											'</div>';
									} else {
										clpbtn +=
												'<strong class="count text-danger">' + clapCount + '</strong> ' +
											op.btnText + ' </button>';
									}
								} else {
									clpbtn += op.btnText + ' </button>';
								}

						clpbtn +=
							'</span>';

						// 評価
						if (op.inputEval) {
							for (var i = 1; i <= 5; i++) {
								var flg;
								if (i <= clapData.evalmean) {
									clpbtn += '<img src="' + rootUrl + path.imgDir + path.star1Img + '" width="11" height="11" />';
								} else if ( ! flg && (clapData.evalmean - Math.floor(clapData.evalmean)) >= 0.5) {
									clpbtn += '<img src="' + rootUrl + path.imgDir + path.star2Img + '" width="11" height="11" />';
									flg = 1;
								} else {
									clpbtn += '<img src="' +  rootUrl + path.imgDir + path.star3Img + '" width="11" height="11" />';
								}
							}
							clpbtn += '(' + clapData.evalmean + ')';
						}

						// 出力
						obj.prepend(clpbtn);
					});
				}).
			end().
			///////// 拍手処理 /////////////////////////////////////////////////////////////////////////////////////////////////////
			on('click', 'button.mwhg_clapbutton', function() {
				var btnObj = $(this);
				var thisctn = btnObj.closest('div.mwhg_point');
				var clapId = thisctn.prop('id');

				// オプション
				var op = $.extend({}, config, thisctn.data('op'));

				// 選択不能化
				btnObj.prop('disabled', true);

				// ローディング画像表示
				var loadImg = thisctn.find('img.mwhg_loading');
				loadImg.show();

				// タイトル取得
				var pageTitle = '';
				if (op.label) {
					pageTitle = $('head > title').html();
				}

				$.ajax({
					data: {
						'mode': 'claping',
						'id' : clapId,
						'label' : pageTitle
					}
				}).
				always(function() {
					// ローディング画像非表示
					loadImg.hide();
					// 選択可能化
					btnObj.prop('disabled', false);
				}).
				fail(function(xhr, status, error) {
					console.log("failed: " + status + ' ' + xhr.status + ' ' + xhr.statusText);
				}).
				done(function(data, status, xhr) {
					// オプション
					op = $.extend({}, config, thisctn.data('op'), data.config);

					// ユーザー個別拍手数
					if ( ! cookie[clapId]) cookie[clapId] = 0;

					// ID数制限
					if (data.status == '_ID_OVER_') {
						alert('拍手ID数が限度を超えています');
						return false;
					}

					// 拍手数制限
					if ((system.cookieCTRL && op.chain > 0 && cookie[clapId] >= op.chain) || data.status == '_CLAPPING_OVER_') {
						alert('拍手数の限度を超えています');
						return false;
					}

					cookie[clapId]++;

					// Cookieセット
					if (system.cookieCTRL) {
						setCookie(clapId, cookie[clapId]);
					}

					// 拍手数加算
					if (op.numViewType != 'none') {
						var clapCount = 0;
						if (system.cookieCTRL && op.numViewType == 'myclap') {
							clapCount = cookie[clapId];
						} else if (system.cookieCTRL && op.numViewType == 'total_myclap') {
							clapCount = (data.clapcnt - cookie[clapId]) + ' + ' + cookie[clapId];
						} else if (op.numViewType == 'total') {
							clapCount = data.clapcnt;
						}
						thisctn.	find('.count').html(clapCount);
					}

					// 加算アニメーション
					if (op.animation) {
						thisctn.prepend('<strong class="count_plus text-danger">+1</strong>').
						children('.count_plus').
							fadeIn(100).
								animate({ 'top' : '-14px' }, 400)
							.delay(300).
							fadeOut(400, function() {
								$(this).remove();
							});
					}

					// メッセージボックス
					if ( ! op.clapOnly) {
						var messbox =
							'<img src="' + rootUrl + path.imgDir + path.closeImg + '" width="28" height="28" class="mwhg_close" data-id="' + clapId + '" alt="閉じる" title="閉じる" />' +
							'<form class="mwhg_messform" data-id="' + clapId + '">' +
								'<p>' + op.thanksClapMessage + '</p>';

								if (op.inputName || op.inputEval || op.inputTkb || op.inputMsg) {
									// 名前入力
									var inputName;
									if (op.inputName) {
										inputName =
											'<input type="text" name="name" value="" class="form-control input-sm" placeholder="名前" /> ';
									}

									// 評価選択
									var inputEval;
									if (op.inputEval) {
										inputEval =
											'<select name="eval" class="form-control input-sm">' +
												'<option value="">評価</option>';
												for (var e = 1; e <= 5; e++) {
													inputEval += '<option value="' + e + '">' + e + '</option>';
												}
											inputEval +=
											'</select>';
									}

									// 名前と評価の項目がある場合横並びにする
									if (op.inputName && op.inputEval) {
										messbox +=
											'<div class="row clearfix">' +
												'<div class="col-sm-7"><div class="form-group">' + inputName + '</div></div>' +
												'<div class="col-sm-5"><div class="form-group">' + inputEval + '</div></div>' +
											'</div>';
									} else {
										if (op.inputName) {
											messbox += '<div class="form-group">' + inputName + '</div>';
										}
										if (op.inputEval) {
											messbox += '<div class="form-group">' + inputEval + '</div>';
										}
									}

									// 定形文選択
									if (op.inputTkb) {
										messbox +=
											'<div class="form-group">' +
												'<select name="tkb" class="form-control input-sm">' +
													'<option value="">▼定形文選択</option>';
													for (var t = 0; t < op.tkb.length; t++) {
														messbox += '<option value="' + op.tkb[t] + '">' + op.tkb[t] + '</option>';
													}
												messbox +=
												'</select>' +
											'</div>';
									}

									// メッセージ入力
									if (op.inputMsg) {
										messbox +=
											'<div class="form-group">' +
												'<textarea name="message" rows="5" class="form-control input-sm" placeholder="メッセージ"></textarea> ' +
											'</div>';
									}

									// 送信ボタン
									messbox +=
											'<input type="submit" value="送信" class="mwhg_submit' + ((op.flat) ? '' : ' gradation') + ' btn btn-primary btn-sm" />';
								}

								// 著作権表示（無断削除禁止）
								messbox +=
								'<div class="text-right">' +
									'<small>' +
										'<a href="http://mcgi.jpn.ch/" target="_blank" class="text-primary">まいるどWEB拍手ぐれーと var' + system.varsion + '</a>' +
									'</small>' +
								'</div>' +
							'</form>';

						// 出力
						btnObj.popover({
							html : true,
							placement : 'bottom',
							trigger : 'manual',
							content : messbox,
							container : 'body'
						}).
						popover('show');

						// $(".popover:has('form.mwhg_messform')").addClass('mwhg');
					}
				});
			});

			$('body').
			///////// メッセージ送信処理 ////////////////////////////////////////////////////////////////////////////////////////////
			on('submit', 'form.mwhg_messform', function(e) {
				e.preventDefault();
				var formObj = $(this);
				var thisctn = $('#' + formObj.data('id'));
				var submBtn = formObj.find('input.mwhg_submit');
				var formSerialize = formObj.serializeArray();

				// オプション
				var op = $.extend({}, config, thisctn.data('op'));

				// 入力チェック
				var formVal = {};
				var valflg = false;
				$.each(formSerialize, function(i, elem) {
					if (elem.value != '') {
						valflg = true;
					}
					formVal[elem.name] = elem.value;
				});
				if ( ! valflg) {
					formObj.find('.alert').remove();
					submBtn.before('<div class="alert alert-danger' + ((op.flat) ? '' : ' gradation') + '">項目を入力してください</div>');
					return;
				}

				// 選択不能化
				submBtn.prop('disabled', true);

				// ローディング画像表示
				var loadImg = thisctn.find('img.mwhg_loading');
				loadImg.show();

				formVal.mode = "send_message";
				formVal.id = thisctn.prop('id');

				$.ajax({
					type: 'POST',
					data: formVal
				}).
				always(function() {
					// ローディング画像非表示
					loadImg.hide();
					// 選択可能化
					submBtn.prop('disabled', false);
				}).
				fail(function(xhr, status, error) {
					var res = xhr.status + ' ' + xhr.statusText;
					alert(res);
				}).
				done(function(data, status, xhr) {
					formObj[0].reset();
					submBtn.before('<div class="alert alert-success' + ((op.flat) ? '' : ' gradation') + '">送信が完了しました</div>');
				});
			}).
			end().
			///////// メッセージボックス削除 ////////////////////////////////////////////////////////////////////////////////////////////
			on({
				'click': function () {
					$('#' + $(this).data('id')).find('.mwhg_clapbutton').popover('destroy');
				},
				'mouseover': function () {
					$(this).prop('src', rootUrl + path.imgDir + path.closeHoverImg);
				},
				'mouseout': function () {
					$(this).prop('src', rootUrl + path.imgDir + path.closeImg);
				}
			}, 'img.mwhg_close');
		});
	});

	///////// Cookie取得 ///////////////////////////////////////////////////////////////////////////////////////////////////
	function getCookie() {
		var result = {};

		var allcookies = document.cookie;
		if (allcookies != '') {
			var cookies = allcookies.split(';');

			for (var i = 0; i < cookies.length; i++) {
				var cookie = cookies[i].split('=');
				// if (cookie[0].replace(/^mwhg_(.+)/, "$1")) {
				if (cookie[0].match(/^mwhg_/)) {
					var valStr = cookie[0].substr(5);
					result[valStr] = decodeURIComponent(cookie[1]);
				}
			}
		}

		return result;
	}
	///////// Cookie設定 ///////////////////////////////////////////////////////////////////////////////////////////////////
	function setCookie(name, value) {
		var expire = new Date();
		// expire.setTime(expire.getTime() + 1000 * 3600 * 24 * 365);
		expire.setFullYear(expire.getFullYear() + 1);
		expire.setHours(expire.getHours() + 9);
		// expire.setDate(expire.getDate() + 1);

		var cookieStr = '';
		cookieStr += 'mwhg_' + name + '=' + encodeURIComponent(value) + ';';
		cookieStr += 'expires=' + expire.toUTCString() + ';';
		// cookieStr += 'domain=' + location.hostname + ';';

		document.cookie = cookieStr;
	}
})(jQuery);
