$(function() {
	//フォームバリデーション
	$.fn.wrapValidate = function(rules) {
		var formObj = $(this);
		formObj.validate(
			$.extend({
				submitHandler: function(form) {
					var submitBtn = formObj.find("input[type='submit'], button[type='submit']");
					submitBtn.button('loading');
					setTimeout(function () {
						submitBtn.button('reset');
					}, 10000);
					// チェックボックス未チェック対策
					formObj.find('input[type="checkbox"]').each(function() {
						if ($(this).prop('checked')) {
							$(this).prev('input[type="hidden"]').prop('disabled', true);
						} else {
							$(this).prev('input[type="hidden"]').prop('disabled', false);
						}
					});
					form.submit();
				},
				errorClass: 'help-block',
				errorElement: 'div',
				errorPlacement: function(error, element) {
					error.appendTo( element.closest("[class^='col']") );
				},
				highlight: function (element) {
					$(element).parents(".form-group").addClass('has-error'); 
				},
				unhighlight: function (element) {
					$(element).parents(".form-group").removeClass('has-error'); 
				}
			}, rules)
		);
	};
});
