<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
//////■ 以下スクリプト ■////
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// 外部ファイル読み込み
require_once('./common.php');

// データ正規化
$PARAM = decode(array_merge($_GET, $_POST));

// ajaxはPOST送信限定
if (is_ajax() && $_SERVER['REQUEST_METHOD'] !== 'POST') {
	error(array('status' => '_LOADING_ERROR_', 'errormsg' => '不正な読み込みです'));
}

// 処理分岐
if (isset($PARAM['mode'])) {
	if ($PARAM['mode'] === 'claping') {
		clap_write();
	} else if ($PARAM['mode'] === 'send_message') {
		message_write();
	}
} else {
	view();
}
exit;
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ メッセージ書き込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function message_write() {
	global $PARAM;

	$ushost = get_host();
	$_clapid = 'mwhg_'. $PARAM['id'];

	// 入力チェック
	if (empty($PARAM['name']) && empty($PARAM['tkb']) && empty($PARAM['message']) && empty($PARAM['eval'])) {
		error(array('status' => '_INPUT_NULL_', 'errormsg' => '項目を入力してください'));
	}

	// $PARAM['name'] = ($PARAM['name'] === '名前') ? '' : $PARAM['name'];
	$newtext = $PARAM['message'];
	if ( ! empty($PARAM['tkb'])) {
		$newtext = '<b>'. $PARAM['tkb']. '</b><br />'. $PARAM['message'];
	}

	// ユーザー個別拍手数
	$ckchain = get_cookie($_clapid, 1);

	//$newtime = time() + 9 * 60 * 60;
	$newtime = time();

	// ▼当日拍手保存ファイル書き込み
	$clapdir = DATADIR. DATEDIR. date("Y");

	if ( ! file_exists($clapdir)) {
		umask(0);
		mkdir($clapdir);
	}

	$dayfile = $clapdir. '/'. date("m-d"). '.dat';

	// ファイルロック実行
	$lfh = file_lock() or die('Busy!');

	if (file_exists($dayfile)) {
		// 既存ファイルから書き込み

		$DFILE = file($dayfile);

		for ($i = 0; $i < count($DFILE); $i++) {
			list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", rtrim($DFILE[$i], "\n"));

			if ($id === $PARAM['id'] && $host === $ushost) {
				if ( ! empty($newtext) && $message === $newtext) {
					error(array('status' => '_DUPLICATE_', 'errormsg' => '既に送信されたメッセージです'));
				}

				$svname = (empty($PARAM['name'])) ? $name : $PARAM['name'];
				$sveval = (empty($PARAM['eval'])) ? $eval : $PARAM['eval'];

				if ($message !== "") $newtext = $message.'<br />'.$newtext;

				$DFILE[$i] = "$time\t$id\t$ushost\t$chain\t$svname\t$sveval\t$newtext\n";
				$flg = 1;
				break;
			}
		}
		if (empty($flg)) {
			array_push($DFILE, "$newtime\t$PARAM[id]\t$ushost\t$ckchain\t$PARAM[name]\t$PARAM[eval]\t$newtext\n");
		}

		$FN = fopen($dayfile, "w");
		fputs($FN, implode('', $DFILE));
		fclose($FN);
	} else {
		// 新規ファイルから書き込み
		$FN = fopen($dayfile, "w");
		fputs($FN, "$newtime\t$PARAM[id]\t$ushost\t$ckchain\t$PARAM[name]\t$PARAM[eval]\t$newtext\n");
		fclose($FN);
	}

	// ▼個別拍手保存ファイル書き込み
	$clapfile = DATADIR. IDDIR. $PARAM['id']. '.json';
	$clapdata = file_read($clapfile);
	$CLAPDATA = json_decode((is_null($clapdata) ? '{"config" : {}}' : $clapdata), true);
	$CLAPCONFIG = array_merge($GLOBALS['clapConfig'], $CLAPDATA['config']);
	if ( ! empty($PARAM['eval']) && ! is_null($clapdata)) {
		// 評価のみ書き換え
		$CLAPDATA['evalcnt']++;
		$CLAPDATA['evalttl'] += $PARAM['eval'];
		$CLAPDATA['evalmean'] = (($CLAPDATA['evalttl'] != 0) && ($CLAPDATA['evalcnt'] != 0)) ? sprintf("%.1f", ($CLAPDATA['evalttl'] / $CLAPDATA['evalcnt'])) : '0.0';

		$FN = fopen($clapfile, "w");
		fputs($FN, json_encode($CLAPDATA));
		fclose($FN);
	}

	// ファイルロック解除
	file_unlock($lfh);

	// メール送信
	if ( ! empty($GLOBALS['system']['mailAddress'])) {
		if (($GLOBALS['system']['mailFlgMsg'] && ! empty($PARAM['message']))
			or ($GLOBALS['system']['mailFlgTkb'] && ! empty($PARAM['tkb']))
			or ($GLOBALS['system']['mailFlgName'] && ! empty($PARAM['name']))
			or ($GLOBALS['system']['mailFlgEval'] && ! empty($PARAM['eval']))) {
			$to = $GLOBALS['system']['mailAddress'];
			$fromadrs = $GLOBALS['system']['mailAddress'];
			$fromname = "まいるどWEB拍手ぐれーと";
			$subject = "【拍手通知】メッセージがありました";
			$body = "以下の内容で拍手メッセージがありました。\n\n".
								"---------------------------------------\n";
			if ( ! empty($PARAM['name'])) $body .= "【名前】". $PARAM['name']. "\n";
			if ( ! empty($PARAM['eval'])) $body .= "【評価】". $PARAM['eval']. "\n";
			if ( ! empty($PARAM['tkb'])) $body .= "【定形文】". $PARAM['tkb']. "\n";
			$body .= "【メッセージ】".  str_replace("<br />", "\n", $PARAM['message']). "\n".
								"【日時】". date("Y/m/d"). '('. week(time()). ') '. date("H:i"). "\n".
								"---------------------------------------\n";
			sendmail($to, $fromadrs, $fromname, $subject, $body);
		}
	}

	// 出力
	if (is_featurephone()) {
		// フューチャーフォン
		tmpoutput(TEMPLATEDIR. MOBILETMPDIR. SENDMSGTMP, $CLAPCONFIG);
	} else if (get_query('ajax') === 'no') {
		// 通常
		tmpoutput(TEMPLATEDIR. NORMALTMPDIR. SENDMSGTMP, $CLAPCONFIG);
	} else if (is_ajax()) {
		// json
		jsonoutput(array());
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 拍手書き込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clap_write() {
	global $PARAM;

	$ushost = get_host();
	$_clapid = 'mwhg_'. $PARAM['id'];

	// 半角英数チェック
	if ( ! preg_match("/^[0-9a-zA-Z_-]+$/", $PARAM['id'])) {
		error(array('status' => '_IDFALSE_', 'errormsg' => 'IDが不正です'));
	}

	// アクセス制限
	foreach ($GLOBALS['system']['denyHosts'] as $host) {
		if ($host === '') continue;
		$denyhost = preg_replace("/\./", "\\.", $host);
		$denyhost = preg_replace("/\*/", ".*", $denyhost);
		if (preg_match("/$denyhost/i", $ushost)) {
			error(array('status' => '_DENYNG_', 'errormsg' => 'アクセスが許可されていません'));
		}
	}

	// 個別拍手保存ファイル読み込み
	$clapfile = DATADIR. IDDIR. $PARAM['id']. '.json';
	$clapdata = file_read($clapfile);
	$CLAPDATA = json_decode((is_null($clapdata) ? '{"config" : {}}' : $clapdata), true);
	$CLAPCONFIG = array_merge($GLOBALS['clapConfig'], $CLAPDATA['config']);

	// ユーザー個別拍手数
	$ckchain = get_cookie($_clapid, 0);
	if ($GLOBALS['system']['cookieCTRL'] && $CLAPCONFIG['chain'] > 0 && $ckchain >= $CLAPCONFIG['chain']) {
		error(array('status' => '_CLAPPING_OVER_', 'errormsg' => '拍手数が上限を超えています'), false);
	}
	$userclapcnt = $ckchain + 1;

	if (is_null($clapdata) && count(wrapglob(DATADIR. IDDIR. "*.json")) >= 3+2) {
		error(array('status' => '_ID_OVER_', 'errormsg' => 'ID数が規定を超えています'));
	}

	// ▼当日拍手保存ファイル書き込み
	//$newtime = time() + 9 * 60 * 60;
	$newtime = time();

	$clapdir = DATADIR. DATEDIR. date("Y");

	if ( ! file_exists($clapdir)) {
		umask(0);
		mkdir($clapdir);
	}

	$dayfile = "$clapdir/". date("m-d"). '.dat';

	// ファイルロック実行
	$lfh = file_lock() or die('Busy!');

	if (file_exists($dayfile)) {
		// 既存ファイルから書き込み

		$DFILE = file($dayfile);

		for ($i = 0; $i < count($DFILE); $i++) {
			list($time, $id, $host, $chain, $name, $eval, $message) = explode("\t", $DFILE[$i]);

			if ($id === $PARAM['id'] && $host === $ushost) {
				$chain++;

				// ホストチェックによる連続拍手制限
				if ($GLOBALS['system']['hostCTRL'] && $CLAPCONFIG['chain'] > 0 && $chain > $CLAPCONFIG['chain']) {
					file_unlock($lfh); // ファイルロック解除
					error(array('status' => '_CLAPPING_OVER_', 'errormsg' => '拍手数が上限を超えています'), false);
				}

				$DFILE[$i] = "$time\t$id\t$ushost\t$chain\t$name\t$eval\t$message";
				$flg = 1;
				break;
			}
		}
		if (empty($flg)) {
			array_push($DFILE, "$newtime\t$PARAM[id]\t$ushost\t$userclapcnt\t\t\t\n");
		}

		$FN = fopen($dayfile, "w");
		fputs($FN, implode('', $DFILE));
		fclose($FN);
	} else {
		// 新規ファイルから書き込み
		$FN = fopen($dayfile, "w");
		fputs($FN, "$newtime\t$PARAM[id]\t$ushost\t$userclapcnt\t\t\t\n");
		fclose($FN);
	}

	// ▼個別拍手保存ファイル書き込み
	if ( ! is_null($clapdata)) {
		// 既存ファイルから書き込み
		$CLAPDATA['clapcnt']++;
		// $CLAPDATA['evalmean'] = (($CLAPDATA['evalttl'] != 0) && ($CLAPDATA['evalcnt'] != 0)) ? sprintf("%.1f", ($CLAPDATA['evalttl'] / $CLAPDATA['evalcnt'])) : '0.0';

		// ラベル／設置元URL（既にある場合は上書きしない）
		if (empty($CLAPDATA['label'])) $CLAPDATA['label'] = $PARAM['label'];
		if (empty($CLAPDATA['url']) && $GLOBALS['system']['getReferer']) $CLAPDATA['url'] = getenv('HTTP_REFERER');

		$FN = fopen($clapfile, "w");
		fputs($FN, json_encode($CLAPDATA));
		fclose($FN);
	} else {
		// 新規ファイルから書き込み
		$CLAPDATA = array(
			'clapcnt' => 1,
			'evalcnt' => 0,
			'evalttl' => 0,
			'evalmean' => '0.0',
			'label' => $PARAM['label'],
			'url' => ($GLOBALS['system']['getReferer']) ? getenv('HTTP_REFERER') : '',
			'config' => array(
				'on' => array(),
			),
		);

		$FN = fopen($clapfile, "w");
		fputs($FN, json_encode($CLAPDATA));
		fclose($FN);
	}

	// ファイルロック解除
	file_unlock($lfh);

	// クッキーセット
	if ($GLOBALS['system']['cookieCTRL'] && ! is_ajax()) {
		$chainset = get_cookie($_clapid, 0) + 1;
		$timeout = time() + 60 * 60 * 24 * 30;
		setcookie($_clapid, $chainset, $timeout, '/', getenv('SERVER_NAME'));
	}

	// 出力
	if (is_featurephone()) {
		// フューチャーフォン
		tmpoutput(TEMPLATEDIR. MOBILETMPDIR. CLAPINGTMP, $CLAPCONFIG);
	} else if (get_query('ajax') === 'no') {
		// 通常
		tmpoutput(TEMPLATEDIR. NORMALTMPDIR. CLAPINGTMP, $CLAPCONFIG);
	} else if (is_ajax()) {
		// json
		jsonoutput($CLAPDATA);
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 拍手ボタン表示
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function view() {
	global $PARAM;

	// 未定義チェック
	if (empty($PARAM['id'])) {
		error(array('status' => '_IDNULL_', 'errormsg' => 'IDを指定してください'));
	}
	// 半角英数チェック
	if ( ! preg_match("/^[0-9a-zA-Z_-]+$/", $PARAM['id'])) {
		error(array('status' => '_IDFALSE_', 'errormsg' => 'IDが不正です'));
	}

	// 個別拍手保存ファイル
	$clapfile = DATADIR. IDDIR. $PARAM['id']. '.json';

	// デフォルト
	$clapdef = array(
		'clapcnt' => 0,
		'evalcnt' => 0,
		'evalttl' => 0,
		'evalmean' => '0.0',
		'label' => '',
		'url' => '',
		'config' => array(
			'on' => array(),
		) + $GLOBALS['clapConfig'],
	);

	// 出力
	if (is_featurephone() || get_query('ajax') === 'no') {
		// 画像出力
		header('HTTP/1.1 200 OK');
		header('Content-Type: image/png');
		if ( ! extension_loaded('gd')) {
			readfile(IMGDIR . ERRORIMG);
		} else {
			$claptext = '';
			$basewidth = 2;
			$baseheight = 15;
			$offset = 2;

			// ファイル読み込み
			$clapdata = file_read($clapfile);
			$CLAPDATA = json_decode((is_null($clapdata) ? json_encode($clapdef) : $clapdata), true);
			$CLAPDATA['config'] = array_merge($GLOBALS['clapConfig'], $CLAPDATA['config']);

			// 拍手数
			if ($CLAPDATA['config']['numViewType'] != 'none') {
				if ($CLAPDATA['config']['numViewType'] === 'total') {
					$claptext .= $CLAPDATA['clapcnt'];
				} else {
					$ckclap = get_cookie('mwhg_'. $PARAM['id'], 0);
					if ($CLAPDATA['config']['numViewType'] === 'myclap') {
						$claptext .= $ckclap;
					} else if ($CLAPDATA['config']['numViewType'] === 'total_myclap') {
						$claptext .= $CLAPDATA['clapcnt'] - ((($CLAPDATA['clapcnt'] - $ckclap) > 0) ? $ckclap : $CLAPDATA['clapcnt']);
						if ($ckclap > 0) $claptext .= '+'. $ckclap;
						$offset += 3;
					}
				}
			}

			// ボタンテキスト
			if ( ! empty($CLAPDATA['config']['btnText'])) {
				$claptext .= ' '. $CLAPDATA['config']['btnText'];
			}

			// 評価
			// $evalflg = ($CLAPDATA['config']['inputEval'] or ( ! $CLAPDATA['config']['inputEval'] && $CLAPDATA['config']['inputEval']));
			if ($CLAPDATA['config']['inputEval']) {
				// 画像サイズ取得
				list($star_w, $star_h) = getImageSize(IMGDIR. STARIMG1);
				$evalmeantext = '('. $CLAPDATA['evalmean']. ')';
				$basewidth += ($star_h * 5) + mb_strwidth($evalmeantext) * 5;
			}

			$offset += mb_strwidth($claptext) * 5;
			$basewidth += $offset;

			// 画像生成
			if (POWERICTC === 1) {
				$imgbase = imageCreateTrueColor($basewidth, $baseheight);
				$bgc = imageColorAllocate($imgbase, 255, 255, 255);
				imageFill($imgbase, 0, 0, $bgc);
			} else {
				$imgbase = imageCreate($basewidth, $baseheight);
				imageColorAllocate($imgbase, 255, 255, 255);
			}
			// 枠
			$bar = imageColorAllocate($imgbase, 221, 221, 221);
			imageRectangle($imgbase, 0, 0, $basewidth - 1, $baseheight - 1, $bar);
			// テキスト
			$claptextcol = imageColorAllocate($imgbase, 153, 51, 51);
			imageTTFText($imgbase, 7, 0, 3, 11, $claptextcol, FONTDIR . GDFONT, $claptext);

			// 評価
			if ($CLAPDATA['config']['inputEval']) {
				for ($i = 1; $i <= 5; $i++) {
					if ($i <= $CLAPDATA['evalmean']) {
						$star = STARIMG1;
					} elseif ( ! isset($flg) && ($CLAPDATA['evalmean'] - floor($CLAPDATA['evalmean'])) >= 0.5) {
						$star = STARIMG2;
						$flg = 1;
					} else {
						$star = STARIMG3;
					}
					$digit = ImageCreateFromPNG(IMGDIR. $star);
					imageCopy($imgbase, $digit, $offset + ($star_w * ($i - 1)), 2, 0, 0, $star_w, $star_h);
					imageDestroy($digit);
				}
				$evmeancol = imageColorAllocate($imgbase, 51, 51, 51);
				imageTTFText($imgbase, 7, 0, $offset + ($star_h * 5) + 2, 11, $evmeancol, FONTDIR . GDFONT, $evalmeantext);
			}

			// 出力
			imagePNG($imgbase);
			imageDestroy($imgbase);
		}
	} else if (is_ajax()) {
		if (file_exists($clapfile)) {
			// JSONファイルを直出力
			header('Content-Type: text/html; charset: utf-8');
			readfile(DATADIR. IDDIR. $PARAM['id']. '.json');
		} else {
			jsonoutput($clapdef);
		}
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ メール送信
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function sendmail($to, $fromadrs, $fromname, $subject, $body) {
	switch (MAILDEVISE) {
		case 'smtp':
			require_once(LIBRARYDIR. QDMAIL);
			require_once(LIBRARYDIR. QDSMTP);
			$mail = new Qdmail();
			$mail->smtp(true);
			$param = array(
				'host' => MAILHOST,
				'port'=> MAILPORT,
				'protocol' => MAILAPROTOCOL,
				'user' => MAILUSER,
				'pass' => MAILPASSWORD,
				'from' => MAILADDRESSES,
			);
			$mail->smtpServer($param);
			$mail->to($to);
			$mail->from($fromadrs, $fromname);
			$mail->subject($subject);
			$mail->text($body);
			$mail->send();
			break;
		case 'mail':
			$body = mb_convert_encoding($body, "JIS", "auto");
			$fromname = mb_encode_mimeheader($fromname);
			$from = 'From: '. $fromname. '<'. $fromname. '>';
			mb_send_mail($to, $subject, $body, $from);
			break;
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ Ajax判定
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function is_ajax() {
	$flg = false;
	if (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower(getenv('HTTP_X_REQUESTED_WITH')) === 'xmlhttprequest') {
		$flg = true;
	}
	return $flg;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 携帯デバイス判定
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function is_featurephone() {
	$flg = false;
	// タブレット端末は除く
	if (preg_match("/(DoCoMo|SoftBank|Vodafone|J-PHONE|KDDI-|UP\.Browser|DDIPOCKET|WILLCOM)/i", getenv('HTTP_USER_AGENT'))
	and ! preg_match("/(iPhone|iPod|iPad|Android|BlackBerry|Windows\ Phone)/i", getenv('HTTP_USER_AGENT'))
		) {
		$flg = true;
	}
	return $flg;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ホスト取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_host() {
	$ref = (getenv('REMOTE_HOST')) ? getenv('REMOTE_HOST') : getenv('REMOTE_HOST');
	if ($ref == "") {
		$ip = (getenv('REMOTE_ADDR')) ? getenv('REMOTE_ADDR') : getenv('REMOTE_ADDR');
		$ref = gethostbyaddr($ip);
	}
	return $ref;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ json出力
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function jsonoutput($data) {
	header('Content-Type: text/html; charset: utf-8');
	echo json_encode($data);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ テンプレート出力
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function tmpoutput($tmp, $ASSIGN = array()) {
	if (is_featurephone()) {
		// フューチャーフォン専用
		ob_start();
		require_once($tmp);
		$contents = ob_get_contents();
		ob_end_clean();
		header('HTTP/1.1 200 OK');
		header('Content-Type: application/xhtml+xml;'); // charset: Shift_JIS
		echo mb_convert_encoding($contents, "SJIS-win", "UTF-8");
	} else {
		require_once($tmp);
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ エラー出力
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function error($assign, $put403 = true) {
	if (is_featurephone()) {
		// フューチャーフォン
		tmpoutput(TEMPLATEDIR. MOBILETMPDIR. ERRORTMP, $assign);
	} else if (get_query('ajax') === 'no') {
		// 通常
		tmpoutput(TEMPLATEDIR. NORMALTMPDIR. ERRORTMP, $assign);
	} else if (is_ajax()) {
		// json
		if ($put403) header('HTTP/1.1 403 Forbidden');
		jsonoutput($assign);
	}
	exit;
}
