<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ selectタグoption生成
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function select_option($option, $selected) {
	if (is_bool($selected)) $selected = ($selected) ? 'true' : 'false';

	$opstr = '';
	foreach ($option as $value => $name) {
		$opstr .= '<option value="'. $value. '"';
		if ($value === $selected) $opstr .= ' selected="selected"';
		$opstr .= '>'. $name. '</option>';
	}
	return $opstr;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ inputタグcheckboxタイプのchecked判定
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function checkbox_checked($value) {
	$checked = '';
	if ($value) {
		$checked = 'checked="checked"';
	}
	return $checked;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 曜日名取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function week($time) {
	$week = array("日", "月", "火", "水", "木", "金", "土");
	return $week[date("w", $time)];
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ POSTパラメータ取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_post($str, $def = null) {
	$value = null;
	if (isset($_POST[$str])) {
		$value = $_POST[$str];
	} else if ( ! is_null($def)) {
		$value = $def;
	}
	return $value;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ GETパラメータ取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_query($str, $def = null) {
	$value = null;
	if (isset($_GET[$str])) {
		$value = $_GET[$str];
	} else if ( ! is_null($def)) {
		$value = $def;
	}
	return $value;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ COOKIE取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_cookie($str, $def = null) {
	$value = null;
	if (isset($_COOKIE[$str])) {
		$value = $_COOKIE[$str];
	} else if ( ! is_null($def)) {
		$value = $def;
	}
	return $value;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ SESSION取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_session($str, $def = null) {
	$value = null;
	if (isset($_SESSION[$str])) {
		$value = $_SESSION[$str];
	} else if ( ! is_null($def)) {
		$value = $def;
	}
	return $value;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ セッションID再生成
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function session_regenerate() {
	$sess_tmp = $_SESSION;
	session_destroy();
	session_id(hash('sha256', (uniqid(mt_rand(), true))));
	session_start();
	$_SESSION = $sess_tmp;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ デコード
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function decode($param) {
	if (is_array($param)) {
		foreach ($param as &$str) {
			$str = decode($str);
		}
	} else {
		$param = mb_convert_encoding($param, "UTF-8", "auto");
		$param = htmlspecialchars($param, ENT_QUOTES, "UTF-8");
		$param = str_replace("\0", '', $param);
		$param = str_replace("\t", ' ', $param);
		$param = preg_replace("/\r\n|\n|\r/", "<br />", $param);
		if (get_magic_quotes_gpc() == 1) $param = stripslashes($param);
	}
	return $param;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ファイル検索
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function wrapglob($pattern) {
	$ret = glob($pattern, GLOB_NOCHECK + GLOB_BRACE);
	if (is_array($ret)) {
		if (count($ret) == 0 || $ret[0] === $pattern) {
			return array();
		} else {
			return $ret;
		}
	} else {
		return array();
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ファイルロード
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function file_read($file, $type = false) {
	if (file_exists($file)) {
		if ($type) {
			return file($file);
		} else {
			return file_get_contents($file);
		}
	} else {
		if ($type) {
			return array();
		} else {
			return null;
		}
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ファイルロック
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function file_lock($options = array()) {
	$lfh = array_merge(array(
		'dir'	 => FILELOCKDIR,
		'basename' => 'lockfile',
		'timeout' => 60,
		'trytime' => 10
		), $options
	);
	$lfh['path'] = $lfh['dir']. $lfh['basename'];

	for ($i = 0; $i < $lfh['trytime']; $i++, sleep(1)) {
		if (rename($lfh['path'], $lfh['current'] = $lfh['path'] . time())) {
			return $lfh;
		}
	}
	$filelist = scandir($lfh['dir']);
	foreach ($filelist as $file) {
		if (preg_match('/^' . $lfh['basename'] . '(\d+)/', $file, $matches)) {
			if (time() - $matches[1] > $lfh['timeout']
			and rename($lfh['dir']. $matches[0],
						$lfh['current'] = $lfh['path'] . time())
			) {
				return $lfh;
			}
			break;
		}
	}
	return false;
}
function file_unlock($lfh) {
	rename($lfh['current'], $lfh['path']);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ リダイレクト
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function location($url) {
	header("HTTP/1.1 301 Moved Permanently");
	header("Status: 301 Moved Permanently");
	header("Location: ". $url);
	exit;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 定数取得用
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
class define_parse {
	public function get($defineKey){
		return constant($defineKey);
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ エラー403出力
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function error403() {
	header('HTTP/1.1 403 Forbidden');
	exit;
}
